/*
 *	main.c
 *
 *	plǂ
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Sat Oct 9 19:57:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 *	* Sat Oct 9 21:35:00 JST 2002 Naoyuki Sawa
 *	- 󒆂Ńplł܂oOB
 *	@Oo[Wł͂ȏ󋵂ŋ󒆂ŕł܂Ă܂B
 *	  @@@@@@@~~~
 *	  @@ˁ@@@ˁ@@
 *	  @@@@@@
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define RND(a,b)	((a) + rand() % ((b) - (a) + 1)) /* a..b̗ */

/* pl */
typedef struct _PANEL {
	short type;				/* 0:/1`MAX_PANEL: */
	short stat;				/* (PS_*) */
	short mark;				/* Ń}[N(bit0=1:/bit1=1:c) */
	short cnt1;				/* ėpJE^1 */
	short cnt2;				/* ėpJE^2 */
	short cnt3;				/* ėpJE^3 */
} PANEL;
#define MAX_PANEL	 6			/* pl̎ސ */
#define PANEL_COLS	 6			/* pl */
#define PANEL_ROWS	12			/* pls */
#define FALL_DELAY	SEC(0.1)		/* JnfBC */
#define ERASE_FLASH	SEC(1)			/* Ŏ_Ŏ */
#define ERASE_DELAY	SEC(0.2)		/* ŃGtFNgԊu */
#define RAISE_DELAY	SEC(0.5)		/* ŏI`pl㏸ĊJfBC */
/* (stat) */
#define PS_NORMAL	0			/* ʏ   */
#define PS_MOVE		1			/* ړ */
						/* cnt1: l=Eړ(-80) */
						/*       l=ړ( 80) */
#define PS_FALL		2			/*  */
						/* cnt1: JnJEg_E(0͈̃Zɕ\) */
						/* cnt2: p^[炵(1`3AJEg_E˂܂) */
#define PS_ERASE	3			/* Œ */
						/* cnt1: tbVpԃJEg_E */
						/* cnt2: ŃGtFNgJEg_E */
						/* cnt3: Ō҂ԃJEg_E     */
/* ŃGtFNg */
typedef struct _ERASE {
	short stat;				/* 0:/1:o */
	short x, y;				/* ʒu(pl̍Wŕ\Apl㏸ɂ͂ėȂ) */
	short cnt;				/* Aj[VJE^ */
} ERASE;
#define MAX_ERASE	16			/* ŃGtFNgo */

/* (wi) */
typedef struct _STAR {
	int x, y;				/* ݈ʒu(24.8bit) */
	int vx, vy;				/* ړx(24.8bit) */
} STAR;
#define MAX_STAR	64			/* ̏o */

/* ьWϊ */
typedef struct _VDIR {
	char vcol;				/* c */
	char vrow;				/*  */
} VDIR;
static const VDIR vdir[4] = {
	{  1,  0 },				/* 0:E (ʏ̕єŗp) */
	{  0,  1 },				/* 1: (ʏ̕єŗp) */
	{ -1,  0 },				/* 2: (VKploɗp) */
	{  0, -1 },				/* 3: (VKploɗp) */
};
#define DIR_RI		0
#define DIR_DN		1
#define DIR_LF		2
#define DIR_UP		3

/* Q[ */
typedef struct _GI {
	int score;				/* XRA */
	int level;				/* x */
	int spdlv;				/* xx */
	int blocks;				/* ݂̃xŏubN */
	int combo;				/* ݂̘A */
	int no_active;				/* ANeBuԂ̃t[JE^ */

	int stat;				/* (GS_*) */
	int cnt;				/* ėpJE^ */
	int anm;				/* ʃAj[VJE^ */

	int cursor_col;				/* J[\ */
	int cursor_row;				/* J[\s */

	int raise_delay;			/* pl㏸ꎞ~ԃJEg_E */
	int panel_ofs;				/* pl㏸ItZbg(24.8bitA0x8000x000) */
	int panel_stop;				/* pl㏸~ԃJEg_E */

	unsigned char panel_warn[PANEL_COLS];	/* 0:ʏ/1:x */
	int panel_warn_anm;			/* xAj[VJE^  */
	PANEL panel[PANEL_ROWS][PANEL_COLS];	/* plz */
	ERASE erase[MAX_ERASE];			/* ŃGtFNg */

	STAR star[MAX_STAR];			/* (wi) */
} GI;
/* (stat) */
#define GS_READY	0			/* "READY?" */
#define GS_NORMAL	1			/* ʏ */
#define GS_STOP		2			/* ㏸~ */
#define GS_OUT		3			/* AEg */
#define GS_GAMEOVER	4			/* "GAME OVER" */

static const char* level_str[MAX_PANEL + 1] = {
	NULL, /* 0:gps */
	NULL, /* 0:gps */
	NULL, /* 0:gps */
	NULL, /* 0:gps */
	"EASY",   /* 4 */
	"NORMAL", /* 5 */
	"HARD",   /* 6 */
};
#define MIN_LEVEL	(MAX_PANEL - 2)
#define MAX_LEVEL	(MAX_PANEL    )

static const short speed_tbl[100] = {
	/*gps*/0
	/* 1*/ ,0x004
	/* 2*/ ,0x008
	/* 3*/ ,0x010
	/* 4*/ ,0x011
	/* 5*/ ,0x011
	/* 6*/ ,0x012
	/* 7*/ ,0x012
	/* 8*/ ,0x013
	/* 9*/ ,0x014
	/*10*/ ,0x014
	/*11*/ ,0x015
	/*12*/ ,0x015
	/*13*/ ,0x016
	/*14*/ ,0x017
	/*15*/ ,0x017
	/*16*/ ,0x018
	/*17*/ ,0x019
	/*18*/ ,0x019
	/*19*/ ,0x01a
	/*20*/ ,0x01b
	/*21*/ ,0x01c
	/*22*/ ,0x01c
	/*23*/ ,0x01d
	/*24*/ ,0x01e
	/*25*/ ,0x01f
	/*26*/ ,0x020
	/*27*/ ,0x021
	/*28*/ ,0x022
	/*29*/ ,0x023
	/*30*/ ,0x024
	/*31*/ ,0x025
	/*32*/ ,0x026
	/*33*/ ,0x027
	/*34*/ ,0x028
	/*35*/ ,0x029
	/*36*/ ,0x02b
	/*37*/ ,0x02c
	/*38*/ ,0x02d
	/*39*/ ,0x02e
	/*40*/ ,0x030
	/*41*/ ,0x031
	/*42*/ ,0x033
	/*43*/ ,0x034
	/*44*/ ,0x036
	/*45*/ ,0x037
	/*46*/ ,0x039
	/*47*/ ,0x03a
	/*48*/ ,0x03c
	/*49*/ ,0x03e
	/*50*/ ,0x040
	/*51*/ ,0x041
	/*52*/ ,0x043
	/*53*/ ,0x045
	/*54*/ ,0x047
	/*55*/ ,0x049
	/*56*/ ,0x04b
	/*57*/ ,0x04e
	/*58*/ ,0x050
	/*59*/ ,0x052
	/*60*/ ,0x054
	/*61*/ ,0x057
	/*62*/ ,0x059
	/*63*/ ,0x05c
	/*64*/ ,0x05f
	/*65*/ ,0x061
	/*66*/ ,0x064
	/*67*/ ,0x067
	/*68*/ ,0x06a
	/*69*/ ,0x06d
	/*70*/ ,0x070
	/*71*/ ,0x073
	/*72*/ ,0x077
	/*73*/ ,0x07a
	/*74*/ ,0x07e
	/*75*/ ,0x081
	/*76*/ ,0x085
	/*77*/ ,0x089
	/*78*/ ,0x08d
	/*79*/ ,0x091
	/*80*/ ,0x095
	/*81*/ ,0x099
	/*82*/ ,0x09e
	/*83*/ ,0x0a2
	/*84*/ ,0x0a7
	/*85*/ ,0x0ac
	/*86*/ ,0x0b1
	/*87*/ ,0x0b6
	/*88*/ ,0x0bb
	/*89*/ ,0x0c0
	/*90*/ ,0x0c6
	/*91*/ ,0x0cc
	/*92*/ ,0x0d2
	/*93*/ ,0x0d8
	/*94*/ ,0x0de
	/*95*/ ,0x0e4
	/*96*/ ,0x0eb
	/*97*/ ,0x0f2
	/*98*/ ,0x0f8
	/*99*/ ,0x100
};
#define MIN_SPDLV	 1
#define MAX_SPDLV	99

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

extern const unsigned char PAT[];
extern const unsigned char BG1[];
extern const unsigned char BG2[];
TEXTURE pat;
TEXTURE bg1;
TEXTURE bg2;

char sin_tbl[SEC(3)];		/* wiLpTCe[u */

int hiscore;			/* nCXRA */
int level_sel = MIN_LEVEL;	/* xI */
int spdlv_sel = MIN_SPDLV;	/* xxI */
int bgchr_sel;			/* wiLI */

GI gi;				/* Q[ */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
int chain_count(int col, int row, int dir);
void field_disp();
void erase_gen();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
		bgchr_sel = !bgchr_sel; /* wiLύX */
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	{
		int i;
		srand(pceTimerGetCount());
		/* rbg}bvB */
		texture_init(&pat, PAT);
		texture_init(&bg1, BG1);
		texture_init(&bg2, BG2);
		/* TCe[u쐬B */
		for(i = 0; i < (sizeof sin_tbl / sizeof *sin_tbl); i++) {
			sin_tbl[i] = floor(sin(PI2 * (float)i / (sizeof sin_tbl / sizeof *sin_tbl)) * 8);
		}
	}
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

	int pause, x, y;
	unsigned char save[PAUSE_H][PAUSE_W];

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

	/* pl|́A㉺EL[ɍI[gs[g܂B */
	{
		static unsigned char cnt[4];
		int i;
		for(i = 0; i < 4; i++) {
			if(joy & (0x01 << i)) {
				if(cnt[i] != 0xff) cnt[i]++;
				if(cnt[i] >= SEC(0.33)) joy |= (0x100 << i);
			} else {
				cnt[i] = 0;
			}
		}
	}

#undef PAUSE_FONT
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, sel, n, x, y;
	char str[100];
	unsigned char *p, c;

	sel = 0;
	for(;;) {
		schedule();
		for(y = 0, p = vbuff; y < DISP_Y; y++) {
			c = y & 1;
			for(x = 0; x < DISP_X; x++, p++) {
				*p = (c ^= 1);
			}
		}

		/* X^[gHIH */
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}
		if(joy & TRG_A) {
			result = 0;
			break;
		}

		/* ^Cg\B */
		sprintf(str, "plǂ");
		x = (DISP_X - (5 * strlen(str) + 2)) / 2;
		y = (DISP_Y - (10 + 2)) / 3;
		render_string_framed(&render, x, y, str, 0, 0x131);

		/* XRA\B */
		sprintf(str, "HI");
		x = 0 + 1;
		y = 0 + 1;
		render_string(&render, x, y, str, 2, 3);
		sprintf(str, "%d", hiscore);
		x = 0 + 1;
		y = 8 + 1;
		render_string(&render, x, y, str, 2, 3);
		sprintf(str, "1P");
		x = DISP_X - (strlen(str) * 4);
		y = 0 + 1;
		render_string(&render, x, y, str, 2, 3);
		sprintf(str, "%d", gi.score);
		x = DISP_X - (strlen(str) * 4);
		y = 8 + 1;
		render_string(&render, x, y, str, 2, 3);

		/* xEXs[hxIB */
		if(joy & TRG_UP) sel = 0;
		if(joy & TRG_DN) sel = 1;
		if(sel == 0) {
			if((joy & TRG_LF) && (spdlv_sel > MIN_SPDLV)) spdlv_sel--;
			if((joy & TRG_RI) && (spdlv_sel < MAX_SPDLV)) spdlv_sel++;
		} else {
			if((joy & TRG_LF) && (level_sel > MIN_LEVEL)) level_sel--;
			if((joy & TRG_RI) && (level_sel < MAX_LEVEL)) level_sel++;
		}

		/* Xs[hx\B */
		sprintf(str, "SPEED %2d", spdlv_sel);
		x = (DISP_X - (strlen(str) * 4 + 1)) / 2;
		y = 72;
		render_string_framed(&render, x, y, str, 2, sel == 0 ? 0x130 : 0x121);
		n = (spdlv_sel + 1) / 2; /* 0`50 */
		x = (DISP_X - 50) / 2;
		y = 81;
		render_rectangle_fill(&render, x, y, n, 4, sel == 0 ? 2 : 1);
		render_line(&render, x, y - 1, x + 50, y - 1, sel == 0 ? 3 : 2);
		render_line(&render, x, y + 4, x + 50, y + 4, sel == 0 ? 3 : 2);
		render_line(&render, x - 1, y, x - 1, y + 4, sel == 0 ? 3 : 2);
		render_line(&render, x + 50, y, x + 50, y + 4, sel == 0 ? 3 : 2);

		/* x\B */
		n = sel == 1 ? 0x130 : 0x121;
		x = (DISP_X - (16 * 4)) / 2;
		y = 95;
		switch(level_sel - MIN_LEVEL) {
		case 0:
			render_string_framed(&render, x-1, y-1, "EASY            ", 2, n);
			render_string       (&render, x  , y  , "     NORMAL HARD", 2, n >> 4 & 0xf);
			break;
		case 1:
			render_string_framed(&render, x-1, y-1, "     NORMAL     ", 2, n);
			render_string       (&render, x  , y  , "EASY        HARD", 2, n >> 4 & 0xf);
			break;
		case 2:
			render_string_framed(&render, x-1, y-1, "            HARD", 2, n);
			render_string       (&render, x  , y  , "EASY NORMAL     ", 2, n >> 4 & 0xf);
			break;
		default:
			DIE();
		}

		/* vvg\B */
		if(now % SEC(1.0) < SEC(0.67)) {
			sprintf(str, " A START");
			x = (DISP_X - (strlen(str) * 5 + 1)) / 2;
			y = DISP_Y - 6 * 3;
			render_string(&render, x, y, str, 0, 3);
			sprintf(str, "SEL EXIT");
			x = (DISP_X - (strlen(str) * 5 + 1)) / 2;
			y = DISP_Y - 6 * 2;
			render_string(&render, x, y, str, 0, 3);
		}
	}

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

static void
bganm_init()
{
	int i;
	STAR* star;

	for(i = 0, star = gi.star; i < MAX_STAR; i++, star++) {
		star->x = DISP_X << 8; /* ɍďo */
		star->y = DISP_Y << 8;
	}
	gi.anm = 0;
}

static void
bganm_work()
{
	int i, n;
	STAR* star;

	/* wi̐ړAʊOȂďo܂B */
	for(i = 0, star = gi.star; i < MAX_STAR; i++, star++) {
		star->x += star->vx;
		star->y += star->vy;
		if(star->x >= DISP_X << 8 || star->y >= DISP_Y << 8) {
			n = RND(0, (DISP_X - 1) + (DISP_Y - 1));
			if(n <= (DISP_X - 1)) {
				star->x = n << 8;
				star->y = 0;
			} else {
				n -= (DISP_X - 1);
				star->x = 0;
				star->y = n << 8;
			}
			n = RND(SEC(0.25), SEC(1.5));
			star->vx = ((DISP_X << 8) - star->x) / n;
			star->vy = ((DISP_Y << 8) - star->y) / n;
		}
	}
	gi.anm++;
}

void
game()
{
	int i, n, n1, n2, n3, col, row, x, y;
	PANEL *panel, *panel2, panel_tmp;
	ERASE* erase;

	memset(&gi, 0, sizeof gi);
	gi.level = level_sel;
	gi.spdlv = spdlv_sel;
	gi.panel_ofs = 0x800;

	/* ubNoBiȂeLg[j */
	{
		unsigned char cnt[PANEL_COLS];
		/* ẽubNB */
		memset(cnt, 0, sizeof cnt);
		for(i = 0; i < PANEL_COLS * PANEL_ROWS / 3; i++) {
			do {
				col = RND(0, PANEL_COLS - 1);
			} while(cnt[col] >= PANEL_ROWS * 2 / 3);
			cnt[col]++;
		}
		/* ŉsȊÕubNB */
		for(col = 0; col < PANEL_COLS; col++) {
			for(row = PANEL_ROWS - 2; row >= PANEL_ROWS - cnt[col]; row--) {
				n = 0;
L30:				gi.panel[row][col].type = RND(1, gi.level);
				if(chain_count(col, row, DIR_LF) >= 3 && (n++ < 10)) goto L30;
				if(chain_count(col, row, DIR_RI) >= 3 && (n++ < 10)) goto L30;
				if(chain_count(col, row, DIR_UP) >= 3 && (n++ < 10)) goto L30;
				if(chain_count(col, row, DIR_DN) >= 3 && (n++ < 10)) goto L30;
			}
		}
		/* ŉs̃ubNB */
		row = PANEL_ROWS - 1;
		for(col = 0; col < PANEL_COLS; col++) {
			n = 0;
L40:			gi.panel[row][col].type = RND(1, gi.level);
			if(chain_count(col, row, DIR_LF) >= 3 && (n++ < 10)) goto L40;
			if(chain_count(col, row, DIR_RI) >= 3 && (n++ < 10)) goto L40;
			if(chain_count(col, row, DIR_UP) >= 3 && (n++ < 10)) goto L40;
			if(chain_count(col, row, DIR_DN) >= 3 && (n++ < 10)) goto L40;
		}
	}

	/* wiAj[VB */
	bganm_init();

	/* "READY" */
	gi.stat = GS_READY;
	gi.cursor_col = PANEL_COLS - 2;
	gi.cursor_row = -2; /* ʊOo */
	for(i = 0; i < SEC(2); i++) {
		schedule();
		gi.cnt = i;
		if(gi.cursor_row < PANEL_ROWS / 2) {
			gi.cursor_row++;
		} else if(gi.cursor_col > PANEL_COLS / 2 - 1) {
			gi.cursor_col--;
		}
		bganm_work();
		field_disp();
		x =  4 + (49 - 26) / 2;
		y = 23 + (97 - 11) / 2;
		render_string_framed(&render, x, y, "READY", 0, 0x203);
	}

	gi.stat = GS_NORMAL;
	for(;;) {
		schedule();

		/*---------------------- ŃGtFNgAj[V ----------------------*/

		/* ŃGtFNg`\̊ԈȊOōsƁIłȂƂPt[ڂ`܂B */
		erase = &gi.erase[0];
		for(i = 0; i < MAX_ERASE; i++, erase++) {
			if(!erase->stat) continue;
			erase->cnt++;
			if(erase->cnt >= 8) memset(erase, 0, sizeof(ERASE));
		}

		/*---------------------- pl㏸ ----------------------*/

		panel = &gi.panel[0][0];
		for(row = 0; row < PANEL_ROWS - 1; row++) {
			for(col = 0; col < PANEL_COLS; col++, panel++) {
				if(!panel->type) continue;
				if(panel->stat == PS_ERASE) {
					gi.raise_delay = RAISE_DELAY; /* pl㏸ꎞ~Ԃݒ */
					goto L10; /* ㏸͕s */
				}
			}
		}
		if(joy & PAD_B) { /* ㏸ */
			gi.panel_ofs &= ~0xff;
			gi.raise_delay = 0; /* plŌ̏㏸fBCLZ */
			gi.panel_stop = 0; /* pl㏸~LZ */
		}
L10:
		if(gi.raise_delay) {
			gi.raise_delay--;
		} else {
			if(gi.panel_stop > 0) { /* pl㏸~H */
				gi.panel_stop--;
			} else {
				gi.panel_ofs -= speed_tbl[gi.spdlv];
			}
			while(gi.panel_ofs <= 0) {
				/* ŏiɃplAQ[I[o[łB */
				panel = &gi.panel[0][0];
				for(i = 0; i < PANEL_COLS; i++, panel++) {
					if(panel->type) break;
				}
				if(i < PANEL_COLS) goto GAMEOVER;

				/* Spl̍sցB */
				memmove(&gi.panel[0][0], &gi.panel[1][0], sizeof(PANEL) * PANEL_COLS * (PANEL_ROWS - 1));
				gi.panel_ofs += 0x800;
				if(0 < gi.cursor_row) gi.cursor_row--;

				/* ŉiɐVKpl𐶐B */
				col = 0;
				row = PANEL_ROWS - 1;
				panel = &gi.panel[row][col];
				memset(panel, 0, sizeof(PANEL) * PANEL_COLS); /* ܂NA */
				do {
					panel->type = RND(1, gi.level);
					if(chain_count(col, row, DIR_LF) >= 3) continue; /* ɎOтȂ蒼 */
					if(chain_count(col, row, DIR_UP) >= 3) continue; /* cɎOтȂ蒼 */
					col++;
					panel++;
				} while(col < PANEL_COLS);
			}
		}

		/*---------------------- pl ----------------------*/

		/* CɗȂ悤A֑܂B */
		panel = &gi.panel[PANEL_ROWS - 2][PANEL_COLS - 1];
		for(row = PANEL_ROWS - 2; row >= 0; row--) { /* ŉs͑܂ */
			for(col = PANEL_COLS - 1; col >= 0; col--, panel--) {
				if(!panel->type) continue;
				switch(panel->stat) {
				case PS_NORMAL:
CHK_NORMAL:
					/* ̃Z󂫂ȂA܂B */
					panel2 = panel + PANEL_COLS;
					if(!panel2->type) {
						*panel2 = *panel;		/* ̃ZֈړA */
						memset(panel, 0, sizeof(PANEL));/* ̃Z͋󂫂ɂ܂ */
						panel2->stat = PS_FALL;		/* ړ̃Zݒ */
						panel2->cnt1 = FALL_DELAY;	/* JnfBC */
						panel2->cnt2 = 0;		/* Jn܂ł̓p^[̂܂ */
					}
					break;
				case PS_MOVE:
					if(panel->cnt1 < 0) { /* Eړ */
						panel->cnt1 += 4;
						if(panel->cnt1 >= 0) {
							panel->stat = PS_NORMAL;
							goto CHK_NORMAL; /* ȂƋ󒆂ŕł܂ */
						}
					} else { /* Eړ */
						panel->cnt1 -= 4;
						if(panel->cnt1 <= 0) {
							panel->stat = PS_NORMAL;
							goto CHK_NORMAL; /* ȂƋ󒆂ŕł܂ */
						}
					}
					break;
				case PS_FALL:
					if(panel->cnt1) { /* O */
						panel->cnt1--;
						if(!panel->cnt1) panel->cnt2 = 3; /* JnAp^[ύX */
					} else { /*  */
						panel2 = panel + PANEL_COLS;
						if(!panel2->type) { /* ̃Z󂫂ȂAɗ */
							*panel2 = *panel;		/* ̃ZֈړA */
							memset(panel, 0, sizeof(PANEL));/* ̃Z͋󂫂ɂ܂ */
							panel2->cnt2 = 3;		/* nɉ̃Z󂢂čė̉\̂ŁAp^[Đݒ肵܂ */
						} else { /* n */
							if(panel->cnt2) { /* nfBC */
								panel->cnt2--;
							} else { /* n */
								panel->stat = PS_NORMAL;
							}
						}
					}
					break;
				case PS_ERASE:
					if(panel->cnt1) { /* tbV */
						panel->cnt1--;
					} else if(panel->cnt2) { /* ŃGtFNg҂ */
						panel->cnt2--;
						if(!panel->cnt2) erase_gen(col, row);
					} else { /* ő҂ */
						panel->cnt3--;
						if(!panel->cnt3) memset(panel, 0, sizeof(PANEL));
					}
					break;
				default:
					DIE();
				}
			}
		}

		/*---------- Ŕ ----------*/

		/* pl`pl̊ԂŏŔsȂƁBłȂƋ󒆂łł܂܂B */
		/* ł͉s\łBugoto CHK_NORMALvŉ܂B2002/11/09 */

		/* ŃplTă}[N܂B */
		n1 = 0; /* ɏŃubN𐔂܂ */
		n2 = 0; /* ɍőѐݒ肵܂ */
		panel = &gi.panel[0][0];
		for(row = 0; row < PANEL_ROWS - 1; row++) { /* ŉs͑܂ */
			for(col = 0; col < PANEL_COLS; col++, panel++) {
				/* ьB */
				if(!(panel->mark & 1 << DIR_RI)) { /* ɉς݂łȂ... */
					n = chain_count(col, row, DIR_RI);
					if(n >= 3) { /* OшȏȂA񂾃ubNɃ}[N */
						if(n > n2) n2 = n;
						panel2 = panel;
						for(i = 0; i < n; i++) {
							if(!panel2->mark) n1++; /* ̃pl̕тɊ܂܂邱ƂBdJEgȂ悤! */
							panel2->mark |= 1 << DIR_RI;
							panel2 += 1;
						}
						/* _ZFPO_~iѐ|Qj~A
						 * gi.combo͂ƂŃCNĝŁAł͂܂AȂB
						 * āAgi.combo+1Kv邱ƂɒӁI
						 */
						gi.score += 10 * (n - 2) * (gi.combo + 1);
					}
				}
				/* cьB */
				if(!(panel->mark & 1 << DIR_DN)) { /* ɏcς݂łȂ... */
					n = chain_count(col, row, DIR_DN);
					if(n >= 3) { /* OшȏȂA񂾃ubNɃ}[N */
						if(n > n2) n2 = n;
						panel2 = panel;
						for(i = 0; i < n; i++) {
							if(!panel2->mark) n1++; /* ̃pl̕тɊ܂܂邱ƂBdJEgȂ悤! */
							panel2->mark |= 1 << DIR_DN;
							panel2 += PANEL_COLS;
						}
						/* _ZFPO_~iѐ|Qj~A
						 * gi.combo͂ƂŃCNĝŁAł͂܂AȂB
						 * āAgi.combo+1Kv邱ƂɒӁI
						 */
						gi.score += 10 * (n - 2) * (gi.combo + 1);
					}
				}
			}
		}
		if(gi.score > hiscore) hiscore = gi.score; /* nCXRAXV */

		/* Ńpl... */
		if(n1) {
			/* pl㏸~ԐݒB */
			n2 = (n2 - 3) * SEC(1); /* 4т1bA5т2bA... */
			if(n2 > gi.panel_stop) gi.panel_stop = n2;
			/* AAbvB */
			gi.combo++;
			/* ŊJnB */
			n2 = ERASE_DELAY;	/* tbVI`ŃGtFNgfBC(ŒAERASE_DELAY) */
			n3 = ERASE_DELAY * n1;	/* ŃGtFNg`plŃfBC(ŒAERASE_DELAY) */
			panel = &gi.panel[0][0];
			for(row = 0; row < PANEL_ROWS - 1; row++) { /* ŉs͑܂ */
				for(col = 0; col < PANEL_COLS; col++, panel++) {
					if(panel->mark) {
						panel->mark = 0; /* ܂}[N낷 */
						panel->stat = PS_ERASE;
						panel->cnt1 = ERASE_FLASH;
						panel->cnt2 = n2;
						panel->cnt3 = n3;
						n2 += ERASE_DELAY; /* tbVI`ŃGtFNgfBC͂񂾂񒷂Ȃ܂ */
						n3 -= ERASE_DELAY; /* ŃGtFNg`plŃfBC͂񂾂ZȂ܂ */
					}
				}
			}
			/* Xs[hxAbvB */
			gi.blocks += n1;
			while(gi.blocks >= 10) {
				gi.blocks -= 10;
				if(gi.spdlv < MAX_SPDLV) gi.spdlv++;
			}
		}

		/*---------- AI ----------*/

		/* orŃplȂԂ3t[pAAIB */
		panel = &gi.panel[0][0];
		for(row = 0; row < PANEL_ROWS - 1; row++) { /* ŉs͑܂ */
			for(col = 0; col < PANEL_COLS; col++, panel++) {
				if(!panel->type) continue;
				if(panel->stat == PS_FALL || panel->stat == PS_ERASE) {
					gi.no_active = 0; /* t[JEgZbg */
					goto L20;
				}
			}
		}
		if(gi.no_active < 3) {
			gi.no_active++;
			if(gi.no_active == 3) gi.combo = 0;
		}
L20:

		/*---------- J[\ ----------*/

		/* J[\ړB */
		if((joy & TRG_LF) && (0 < gi.cursor_col                 )) gi.cursor_col--;
		if((joy & TRG_RI) && (    gi.cursor_col < PANEL_COLS - 2)) gi.cursor_col++;
		if((joy & TRG_UP) && (0 < gi.cursor_row                 )) gi.cursor_row--;
		if((joy & TRG_DN) && (    gi.cursor_row < PANEL_ROWS - 2)) gi.cursor_row++;

		/* plB(plōsƁIłȂƌ̂Pt[ڂ`悳܂) */
		if(joy & TRG_A) {
			panel = &gi.panel[gi.cursor_row][gi.cursor_col];
			panel2 = panel + 1;
			if(( panel->type ||  panel2->type) && /* EɃubNāc   */
			   (!panel->stat && !panel2->stat)) { /* ǂʏԂȂ\ */
				panel_tmp = *panel;
				            *panel = *panel2;
				                     *panel2 = panel_tmp;
				if(panel->type) {
					panel->stat = PS_MOVE;
					panel->cnt1 = 6; /* 620 */
				}
				if(panel2->type) {
					panel2->stat = PS_MOVE;
					panel2->cnt1 = -6; /* -6-20 */
				}
			}
		}

		/*---------------------- plx\`FbN ----------------------*/

		/* ォiڂɃplA̗xAj[V܂B */
		n = 0;
		panel = &gi.panel[1][0];
		for(col = 0; col < PANEL_COLS; col++, panel++) {
			gi.panel_warn[col] = (panel->type != 0);
			if(gi.panel_warn[col]) n = 1;
		}
		if(n) {
			/* pl㏸~͌xAj[V~܂B */
			if(gi.panel_stop == 0) gi.panel_warn_anm++;
		} else {
			gi.panel_warn_anm = 0; /* x񂪂Ȃ΃Zbg */
		}

		bganm_work();
		field_disp();
	}
GAMEOVER:

	/* "GAMEOVER" */
	gi.stat = GS_OUT;
	for(i = 0; i < SEC(0.5); i++) {
		schedule();
		gi.cnt = i;
		field_disp();
	}
	gi.stat = GS_GAMEOVER;
	for(i = 0; i < SEC(3); i++) {
		schedule();
		gi.cnt = i;
		bganm_work();
		field_disp();
		if(i >= SEC(1)) {
			x =  4 + (49 - 21) / 2;
			y = 23 + (97 - 21) / 2;
			render_string_framed(&render, x, y, "GAME\nOVER", 0, 0x203);
		}
	}
}

/****************************************************************************
 *	chain_count
 ****************************************************************************/

int
chain_count(int col, int row, int dir)
{
	int vcol, vrow, type, cnt;
	PANEL* panel;

	/* w肳ꂽɑΉW擾B */
	vcol = vdir[dir].vcol;
	vrow = vdir[dir].vrow;

	/* ʒũplB */
	panel = &gi.panel[row][col];
	if(!(type = panel->type) || panel->stat) return 0; /* plȂAʏԂłȂ΃JEg܂ */

	cnt = 1; /* _̕܂JEg */
	for(;;) {
		/* ̃plʒuֈړB */
		if(vcol > 0) { /* E */
			col++;
			if(col > PANEL_COLS - 1) return cnt;
			panel += 1;
		} else if(vcol < 0) { /*  */
			col--;
			if(col < 0) return cnt;
			panel -= 1;
		}
		if(vrow > 0) { /*  */
			row++;
			if(row > PANEL_ROWS - 2) return cnt; /* ŏIs̓JEgȂBŏIs̒n߂̂OK(o`FbNp) */
			panel += PANEL_COLS;
		} else if(vrow < 0) { /*  */
			row--;
			if(row < 0) return cnt;
			panel -= PANEL_COLS;
		}
		/* ̈ʒũplB */
		if(panel->type != type || panel->stat) return cnt; /* plႤAʏԂłȂ΃JEg܂ */
		cnt++;
	}
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

/*---------- BG1 ----------*/

/* tB[h(pl) */
#define FIELD_X		 4
#define FIELD_Y		23
#define FIELD_W		49
#define FIELD_H		97

/* CtH[V */
#define INFO_X		56
#define INFO_Y		23
#define INFO_W		29
#define INFO_H		59

/* (HI-SCORE) */
#define INFO1_X		58
#define INFO1_Y		25
#define INFO1_W		25
#define INFO1_H		 5

/* (SCORE) */
#define INFO2_X		58
#define INFO2_Y		39
#define INFO2_W		22
#define INFO2_H		 5

/* (SPEED LV.) */
#define INFO3_X		58
#define INFO3_Y		53
#define INFO3_W		25
#define INFO3_H		 5

/* (LEVEL) */
#define INFO4_X		58
#define INFO4_Y		67
#define INFO4_W		22
#define INFO4_H		 5

/*---------- BG2 ----------*/

/* LN^: c2 */
#define BGCHR_W		80
#define BGCHR_H		88

/*---------- PAT ----------*/

typedef struct _CHR {
	unsigned char x, y;	/* ]`̍W */
	unsigned char w, h;	/* ]TCY */
	unsigned char cx, cy;	/* _ւ̃ItZbg */
} CHR;
enum {
	CHR_PANEL1_NORMAL,CHR_PANEL1_ZURE1,CHR_PANEL1_ZURE2,CHR_PANEL1_ZURE3,CHR_PANEL1_FLASH,CHR_PANEL1_DARK,
	CHR_PANEL2_NORMAL,CHR_PANEL2_ZURE1,CHR_PANEL2_ZURE2,CHR_PANEL2_ZURE3,CHR_PANEL2_FLASH,CHR_PANEL2_DARK,
	CHR_PANEL3_NORMAL,CHR_PANEL3_ZURE1,CHR_PANEL3_ZURE2,CHR_PANEL3_ZURE3,CHR_PANEL3_FLASH,CHR_PANEL3_DARK,
	CHR_PANEL4_NORMAL,CHR_PANEL4_ZURE1,CHR_PANEL4_ZURE2,CHR_PANEL4_ZURE3,CHR_PANEL4_FLASH,CHR_PANEL4_DARK,
	CHR_PANEL5_NORMAL,CHR_PANEL5_ZURE1,CHR_PANEL5_ZURE2,CHR_PANEL5_ZURE3,CHR_PANEL5_FLASH,CHR_PANEL5_DARK,
	CHR_PANEL6_NORMAL,CHR_PANEL6_ZURE1,CHR_PANEL6_ZURE2,CHR_PANEL6_ZURE3,CHR_PANEL6_FLASH,CHR_PANEL6_DARK,
	CHR_FACE1W_NORMAL,CHR_FACE1W_DARK1,CHR_FACE1W_DARK2,CHR_FACE1W_DARK3,
	CHR_FACE2W_NORMAL,CHR_FACE2W_DARK1,CHR_FACE2W_DARK2,CHR_FACE2W_DARK3,
	CHR_FACE1B_NORMAL,CHR_FACE1B_DARK1,CHR_FACE1B_DARK2,CHR_FACE1B_DARK3,
	CHR_FACE2B_NORMAL,CHR_FACE2B_DARK1,CHR_FACE2B_DARK2,CHR_FACE2B_DARK3,
	CHR_ERASE1,CHR_ERASE2,CHR_ERASE3,CHR_ERASE4,CHR_ERASE5,CHR_ERASE6,CHR_ERASE7,CHR_ERASE8,
	CHR_CURSOR1,CHR_CURSOR2,
	CHR_COUNT,
};
static const CHR chr_tbl[CHR_COUNT] = {
	{8*0,16*0-0,9,9+0,0,0 },	/* #1=n[g: +0:ʏ */
	{8*0,16*1-0,9,9+0,0,0},		/*          : +1:Y1 */
	{8*0,16*2-1,9,9+1,0,1},		/*          : +2:Y2 */
	{8*0,16*3-2,9,9+2,0,2},		/*          : +3:Y3 */
	{8*0,16*4-0,9,9+0,0,0},		/*          : +4:tbV */
	{8*0,16*5-0,9,9+0,0,0},		/*          : +5:Â */
	{8*1,16*0-0,9,9+0,0,0},		/* #2=_C */
	{8*1,16*1-0,9,9+0,0,0},
	{8*1,16*2-1,9,9+1,0,1},
	{8*1,16*3-2,9,9+2,0,2},
	{8*1,16*4-0,9,9+0,0,0},
	{8*1,16*5-0,9,9+0,0,0},
	{8*2,16*0-0,9,9+0,0,0},		/* #3=Op */
	{8*2,16*1-0,9,9+0,0,0},
	{8*2,16*2-1,9,9+1,0,1},
	{8*2,16*3-2,9,9+2,0,2},
	{8*2,16*4-0,9,9+0,0,0},
	{8*2,16*5-0,9,9+0,0,0},
	{8*3,16*0-0,9,9+0,0,0},		/* #4= */
	{8*3,16*1-0,9,9+0,0,0},
	{8*3,16*2-1,9,9+1,0,1},
	{8*3,16*3-2,9,9+2,0,2},
	{8*3,16*4-0,9,9+0,0,0},
	{8*3,16*5-0,9,9+0,0,0},
	{8*4,16*0-0,9,9+0,0,0},		/* #5= */
	{8*4,16*1-0,9,9+0,0,0},
	{8*4,16*2-1,9,9+1,0,1},
	{8*4,16*3-2,9,9+2,0,2},
	{8*4,16*4-0,9,9+0,0,0},
	{8*4,16*5-0,9,9+0,0,0},
	{8*5,16*0-0,9,9+0,0,0},		/* #6=Op */
	{8*5,16*1-0,9,9+0,0,0},
	{8*5,16*2-1,9,9+1,0,1},
	{8*5,16*3-2,9,9+2,0,2},
	{8*5,16*4-0,9,9+0,0,0},
	{8*5,16*5-0,9,9+0,0,0},
	{10*0,92+9*0,11,9,1,0},		/* 1: ʏ */
	{10*0,92+9*1,11,9,1,0},		/*      : Â1 */
	{10*0,92+9*2,11,9,1,0},		/*      : Â2 */
	{10*0,92+9*3,11,9,1,0},		/*      : Â3 */
	{10*1,92+9*0,11,9,1,0},		/* 2 */
	{10*1,92+9*1,11,9,1,0},
	{10*1,92+9*2,11,9,1,0},
	{10*1,92+9*3,11,9,1,0},
	{10*2,92+9*0,11,9,1,0},		/* 1 */
	{10*2,92+9*1,11,9,1,0},
	{10*2,92+9*2,11,9,1,0},
	{10*2,92+9*3,11,9,1,0},
	{10*3,92+9*0,11,9,1,0},		/* 2 */
	{10*3,92+9*1,11,9,1,0},
	{10*3,92+9*2,11,9,1,0},
	{10*3,92+9*3,11,9,1,0},
	{56+24*0,24*0,21,21,6,6},	/* ŃGtFNg1 */
	{56+24*0,24*1,21,21,6,6},	/*               2 */
	{56+24*0,24*2,21,21,6,6},	/*               3 */
	{56+24*0,24*3,21,21,6,6},	/*               4 */
	{56+24*1,24*0,21,21,6,6},	/*               5 */
	{56+24*1,24*1,21,21,6,6},	/*               6 */
	{56+24*1,24*2,21,21,6,6},	/*               7 */
	{56+24*1,24*3,21,21,6,6},	/*               8 */
	{102,6+16*0,21,13,2,2},		/* J[\1 */
	{102,6+16*1,21,13,2,2},		/*         2 */
};

/* chr_disp()̓eNX`ύX܂B
 * chr_disp()ĂԑOɁAĂяoŁurender.context->texture = &pat;vsĂB
 */
static void
chr_disp(int x, int y, int chrno)
{
	const CHR* chr;
	if(chrno < 0 || CHR_COUNT - 1 < chrno) DIE();
	chr = &chr_tbl[chrno];
	render_object(&render, x - chr->cx, y - chr->cy, chr->x, chr->y, chr->w, chr->h, DRW_NOMAL);
}
static void
chr_disp2(int x, int y, int chrno, int reduce)
{
	const CHR* chr;
	if(chrno < 0 || CHR_COUNT - 1 < chrno) DIE();
	chr = &chr_tbl[chrno];
	if(reduce < 0) reduce = 0;
	if(reduce >= chr->h) return;
	render_object(&render, x - chr->cx, y - chr->cy, chr->x, chr->y, chr->w, chr->h - reduce, DRW_NOMAL);
}

static const unsigned char panel_chr[MAX_PANEL + 1] = {
	-1,
	CHR_PANEL1_NORMAL,
	CHR_PANEL2_NORMAL,
	CHR_PANEL3_NORMAL,
	CHR_PANEL4_NORMAL,
	CHR_PANEL5_NORMAL,
	CHR_PANEL6_NORMAL,
};
static const unsigned char panel_face[MAX_PANEL + 1] = {
	-1,
	CHR_FACE1W_NORMAL,
	CHR_FACE2B_NORMAL,
	CHR_FACE2W_NORMAL,
	CHR_FACE1B_NORMAL,
	CHR_FACE2W_NORMAL,
	CHR_FACE1B_NORMAL,
};
static const unsigned char panel_warn_pat[] = {0,1,2,3,3,2,1};
static const char face_out_ofs[] = {-2,0,2,0,1,0,-1};

static const char* combo_str[100] = {
	"OA", "PA", "QA", "RA", "SA", "TA", "UA", "VA", "WA", "XA",
	"10A", "11A", "12A", "13A", "14A", "15A", "16A", "17A", "18A", "19A",
	"20A", "21A", "22A", "23A", "24A", "25A", "26A", "27A", "28A", "29A",
	"30A", "31A", "32A", "33A", "34A", "35A", "36A", "37A", "38A", "39A",
	"40A", "41A", "42A", "43A", "44A", "45A", "46A", "47A", "48A", "49A",
	"50A", "51A", "52A", "53A", "54A", "55A", "56A", "57A", "58A", "59A",
	"60A", "61A", "62A", "63A", "64A", "65A", "66A", "67A", "68A", "69A",
	"70A", "71A", "72A", "73A", "74A", "75A", "76A", "77A", "78A", "79A",
	"80A", "81A", "82A", "83A", "84A", "85A", "86A", "87A", "88A", "89A",
	"90A", "91A", "92A", "93A", "94A", "95A", "96A", "97A", "98A", "99A",
};
#define COMBO_X		(FIELD_X + FIELD_W +  1)
#define COMBO_Y		(FIELD_Y + FIELD_H - 10)

#define PSTOP_X		(INFO_X + (INFO_W - 22) / 2)
#define PSTOP_Y		(INFO_Y + INFO_H + 1)

void
field_disp()
{
	int i, col, row, chr, x, y, reduce;
	unsigned char *p, c;
	STAR* star;
	PANEL* panel;
	ERASE* erase;

	memset(vbuff, 1, sizeof vbuff);

	/* wiAj[VB */
	for(i = 0, star = gi.star; i < MAX_STAR; i++, star++) {
		render_line(&render, star->x >> 8, star->y >> 8, (star->x + star->vx) >> 8, (star->y + star->vy) >> 8, 0);
	}
	render.context->texture = &bg2;
	x = (DISP_X - BGCHR_W) / 2;
	y = (DISP_Y - BGCHR_H) / 2 + sin_tbl[gi.anm % (sizeof sin_tbl / sizeof *sin_tbl)];
	render_object(&render, x, y, 0, bgchr_sel * BGCHR_H, BGCHR_W, BGCHR_H, DRW_NOMAL);

	/* tB[hwiECtH[[VwiÂ܂B */
	p = &vbuff[DISP_X * (FIELD_Y + 1) + (FIELD_X + 1)];
	for(y = (FIELD_Y + 1); y < (FIELD_Y + FIELD_H - 1); y++) {
		for(x = (FIELD_X + 1); x < (FIELD_X + FIELD_W - 1); x++) {
			c = *p;
			if(c < 3) *p = c + 1;
			p++;
		}
		p += DISP_X - (FIELD_W - 2);
	}
	p = &vbuff[DISP_X * (INFO_Y + 1) + (INFO_X + 1)];
	for(y = (INFO_Y + 1); y < (INFO_Y + INFO_H - 1); y++) {
		for(x = (INFO_X + 1); x < (INFO_X + INFO_W - 1); x++) {
			c = *p;
			if(c < 3) *p = c + 1;
			p++;
		}
		p += DISP_X - (INFO_W - 2);
	}

	/* tB[hgECtH[Vgƕ`܂B */
	render.context->texture = &bg1;
	render_object(&render, FIELD_X, FIELD_Y, FIELD_X, FIELD_Y, FIELD_W, 1, DRW_NOMAL);
	render_object(&render, FIELD_X, FIELD_Y, FIELD_X, FIELD_Y, 1, FIELD_H, DRW_NOMAL);
	render_object(&render, FIELD_X, FIELD_Y + FIELD_H - 1, FIELD_X, FIELD_Y + FIELD_H - 1, FIELD_W, 1, DRW_NOMAL);
	render_object(&render, FIELD_X + FIELD_W - 1, FIELD_Y, FIELD_X + FIELD_W - 1, FIELD_Y, 1, FIELD_H, DRW_NOMAL);
	render_object(&render, INFO_X, INFO_Y, INFO_X, INFO_Y, INFO_W, 1, DRW_NOMAL);
	render_object(&render, INFO_X, INFO_Y, INFO_X, INFO_Y, 1, INFO_H, DRW_NOMAL);
	render_object(&render, INFO_X, INFO_Y + INFO_H - 1, INFO_X, INFO_Y + INFO_H - 1, INFO_W, 1, DRW_NOMAL);
	render_object(&render, INFO_X + INFO_W - 1, INFO_Y, INFO_X + INFO_W - 1, INFO_Y, 1, INFO_H, DRW_NOMAL);
	render_object(&render, INFO1_X, INFO1_Y, INFO1_X, INFO1_Y, INFO1_W, INFO1_H, DRW_NOMAL);
	render_object(&render, INFO2_X, INFO2_Y, INFO2_X, INFO2_Y, INFO2_W, INFO2_H, DRW_NOMAL);
	render_object(&render, INFO3_X, INFO3_Y, INFO3_X, INFO3_Y, INFO3_W, INFO3_H, DRW_NOMAL);
	render_object(&render, INFO4_X, INFO4_Y, INFO4_X, INFO4_Y, INFO4_W, INFO4_H, DRW_NOMAL);
	render_printf_framed(&render, INFO1_X, INFO1_Y + 6, 2, 0x203, "%6d", hiscore);
	render_printf_framed(&render, INFO2_X, INFO2_Y + 6, 2, 0x203, "%6d", gi.score);
	render_printf_framed(&render, INFO3_X, INFO3_Y + 6, 2, 0x203, "%6d", gi.spdlv);
	render_printf_framed(&render, INFO4_X, INFO4_Y + 6, 2, 0x203, "%6s", level_str[gi.level]);
	switch(gi.stat) {
	case GS_NORMAL:
		if(gi.panel_stop) render_string_framed(&render, PSTOP_X, PSTOP_Y, "STOP", 0, gi.anm & 1 ? 0x130 : 0x132);
		if(gi.combo >= 2) render_string_framed(&render, COMBO_X, COMBO_Y, combo_str[gi.combo], 0, gi.anm & 1 ? 0x130 : 0x132);
		break;
	}

	/* pl`B */
	render.context->texture = &pat;
	switch(gi.stat) {
	case GS_READY:
		/* tB[hɃNbsOB */
		render.left = FIELD_X + 1;
		render.top = FIELD_Y + 1;
		render.right = FIELD_X + FIELD_W - 1;
		render.bottom = FIELD_Y + FIELD_H - 1;
		/* pl\B */
		panel = &gi.panel[0][0];
		for(row = 0; row < PANEL_ROWS; row++) {
			for(col = 0; col < PANEL_COLS; col++, panel++) {
				if(!panel->type) continue;
				chr = panel_chr[(int)panel->type];
				x = FIELD_X + col * 8;
				y = FIELD_Y + row * 8 + ((gi.panel_ofs + 0xff) >> 8);
				if(gi.cnt < SEC(0.25)) {
					/* \Ȃ */
				} else if(gi.cnt < SEC(0.5)) {
					render_rectangle_fill(&render, x, y, 9, 9, 3); /* p^[Yꂽ̂ōhԂ(^^; */
				} else if(gi.cnt < SEC(0.75)) {
					chr_disp(x, y, chr + 5);
				} else {
					chr_disp(x, y, chr);
				}
			}
		}
		/* NbsOB */
		render.left = 0;
		render.top = 0;
		render.right = render.surface->w;
		render.bottom = render.surface->h;
		break;
	case GS_NORMAL:
		/* tB[hɃNbsOB */
		render.left = FIELD_X + 1;
		render.top = FIELD_Y + 1;
		render.right = FIELD_X + FIELD_W - 1;
		render.bottom = FIELD_Y + FIELD_H - 1;
		/* pl\B */
		panel = &gi.panel[0][0];
		for(row = 0; row < PANEL_ROWS; row++) {
			for(col = 0; col < PANEL_COLS; col++, panel++) {
				if(!panel->type) continue;
				chr = panel_chr[(int)panel->type];
				x = FIELD_X + col * 8;
				y = FIELD_Y + row * 8 + ((gi.panel_ofs + 0xff) >> 8);
				switch(panel->stat) {
				case PS_NORMAL:
					if(row == PANEL_ROWS - 1) { /* ŉs͖ňÂ */
						chr += 5;
					} else if(gi.panel_warn[col]) { /* ŉsȊO͌xAj[V */
						chr += panel_warn_pat[gi.panel_warn_anm % (sizeof panel_warn_pat / sizeof *panel_warn_pat)];
					}
					chr_disp(x, y, chr);
					break;
				case PS_MOVE:
					x += panel->cnt1;
					chr_disp(x, y, chr);
					break;
				case PS_FALL:
					if(panel->cnt1) y -= 8; /* O͈̃Zɕ` */
					chr += panel->cnt2;
					chr_disp(x, y, chr);
					break;
				case PS_ERASE:
					if(panel->cnt1) { /* tbV */
						if(panel->cnt1 & 1) chr += 4;
						chr_disp(x, y, chr);
					} else if(panel->cnt2) { /* ŃGtFNg҂ */
						/* ڂ̈ꕔׂ̃pltB[hgɂȂ̂ŁAŕ`܂B */
					} else { /* ő҂ */
						/* \܂B */
					}
					break;
				default:
					DIE();
				}
			}
		}
		/* NbsOB */
		render.left = 0;
		render.top = 0;
		render.right = render.surface->w;
		render.bottom = render.surface->h;
		/* Ŏ̊pl`߂ɁA񂵂܂B */
		panel = &gi.panel[0][0];
		for(row = 0; row < PANEL_ROWS; row++) {
			for(col = 0; col < PANEL_COLS; col++, panel++) {
				if(!panel->type) continue;
				chr = panel_chr[(int)panel->type];
				x = FIELD_X + col * 8;
				y = FIELD_Y + row * 8 + ((gi.panel_ofs + 0xff) >> 8);
				switch(panel->stat) {
				case PS_ERASE:
					if(panel->cnt1) {
						/* ɕ`ς݁B */
					} else if(panel->cnt2) {
						chr = panel_face[(int)panel->type];
						chr_disp(x, y, chr);
					} else {
						/* \܂B */
					}
					break;
				}
			}
		}
		break;
	case GS_OUT:
	case GS_GAMEOVER:
		/* tB[h㉺̂݃NbsOB(ڂ͍Eɂ͂ݏo) */
		//㉺ɂ͂ݏo邱Ƃɂ܂B
		//render.left = 0;
		//render.top = FIELD_Y + 1;
		//render.right = render.surface->w;
		//render.bottom = FIELD_Y + FIELD_H - 1;
		/* \B */
		panel = &gi.panel[0][0];
		for(row = 0; row < PANEL_ROWS; row++) {
			for(col = 0; col < PANEL_COLS; col++, panel++) {
				if(!panel->type) continue;
				chr = panel_face[(int)panel->type];
				x = FIELD_X + col * 8;
				y = FIELD_Y + row * 8;
				reduce = 0;
				switch(gi.stat) {
				case GS_OUT:
					if(gi.cnt < sizeof face_out_ofs / sizeof *face_out_ofs) {
						y += face_out_ofs[gi.cnt];
					}
					break;
				case GS_GAMEOVER:
					if(gi.cnt < 4 * 2) {
						chr += gi.cnt / 2;
					} else {
						chr += 3;
						reduce = gi.cnt - 4 * 2 - (PANEL_ROWS - row);
					}
					break;
				}
				switch(panel->stat) {
				case PS_NORMAL:
				case PS_MOVE:
				case PS_FALL:
				/*case PS_ERASE:Œpl͕\Ȃ*/
					chr_disp2(x, y, chr, reduce);
					break;
				default:
					DIE();
				}
			}
		}
		/* NbsOB */
		//render.left = 0;
		//render.top = 0;
		//render.right = render.surface->w;
		//render.bottom = render.surface->h;
		break;
	default:
		DIE();
	}

	/* J[\\B */
	switch(gi.stat) {
	case GS_READY:
	case GS_NORMAL:
		chr = gi.anm % SEC(0.5) < SEC(0.25) ? CHR_CURSOR1 : CHR_CURSOR2;
		x = FIELD_X + 8 * gi.cursor_col;
		y = FIELD_Y + 8 * gi.cursor_row + ((gi.panel_ofs + 0xff) >> 8);
		chr_disp(x, y, chr);
		break;
	}

	/* ŃGtFNg\B */
	switch(gi.stat) {
	case GS_NORMAL:
		erase = &gi.erase[0];
		for(i = 0; i < MAX_ERASE; i++, erase++) {
			if(!erase->stat) continue;
			chr = CHR_ERASE1 + erase->cnt;
			x = erase->x;
			y = erase->y;
			chr_disp(x, y, chr);
		}
		break;
	}
}

/****************************************************************************
 *	erase_gen
 ****************************************************************************/

void
erase_gen(int col, int row)
{
	int i;
	ERASE* erase;

	/* 󂫃GgT܂B */
	erase = &gi.erase[0];
	for(i = 0; i < MAX_ERASE; i++, erase++) {
		if(!erase->stat) break;
	}
	if(i == MAX_ERASE) return; /* 󂫂Ȃ */

	/* ŃGtFNgB */
	erase->stat = 1;
	erase->x = FIELD_X + col * 8;
	erase->y = FIELD_Y + row * 8 + ((gi.panel_ofs + 0xff) >> 8);
	erase->cnt = 0;
}
