/*	
 *	clippce.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Wed Apr 24 09:26:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Sun Jun  2 04:45:00 JST 2002 Naoyuki Sawa
 *	- pceAppInit()ōpceLCDDrawObjectCXg[A
 *	  pceAppExit()ōpceLCDDrawObjectACXg[悤ɂ܂B
 *	  AAvP[Vł̍ƂsKv͂܂B
 *	* Sun Jun  2 20:07:00 JST 2002 Naoyuki Sawa
 *	- pceLCDDrawObject()clipdobj.cɕB
 *	* Thu May 13 22:00:00 JST 2002 Naoyuki Sawa
 *	- 󂫃̑啔malloc()pq[vƂĊmۂ悤ɕύXB
 *	- s\̂鏉ApceAppInit()app_init()ɕB
 *	- ʃx֐/_~[֐̍쐬JnB
 *	* Fri Jun 21 19:22:00 JST 2002 Naoyuki Sawa
 *	- GSM̃[eBeB֐ǉB
 *	* Fri Jun 22 09:09:00 JST 2002 Naoyuki Sawa
 *	- 荞݃[`gsm_isr()Apsr󂵂Ă܂Ă̂CB
 *	  GSMĐ[`ɂĊm̃oO͂Ƃ肠SԂƎvB
 *	* Wed Jun 26 23:28:00 JST 2002 Naoyuki Sawa
 *	- usleep()ǉB
 *	- lcd_init()ǉBpceAppInit()ŕKĂԂ悤ɂ܂B
 *	* Sta Jun 29 21:11:00 JST 2002 Naoyuki Sawa
 *	- GSMĐ֐̃vtBXNstream_*gsm_*ɕύXB
 *	  GSMCů֐ƂԂ鋰ꂪ̂stream_*ɂĂ܂A
 *	  ǂvȂ̂ŁA킩₷gsm_*ɕύX܂B
 *	* Tue Jul  2 19:00:00 JST 2002 Naoyuki Sawa
 *	- fpak_find()̃oOCB
 *	  t@C̓ǂݍ݈ʒu(ofs)i߂̂YĂ߁A
 *	  ŏ̃t@CȊO͌Ȃ̂C܂B
 *	- malloc()pq[v0x77Ŗ߂Ă悤ɂ܂BifobOՂ悤Ɂj
 *	* Thu Jul  4 05:30:00 JST 2002 Naoyuki Sawa
 *	- file_inflate_size(),fpak_inflate_size()ǉB
 *	  zlibk`ɂ́AkÕt@C̃TCY܂܂ĂȂłB
 *	* Sat Oct 12 06:07:00 JST 2002 Naoyuki Sawa
 *	- zlib֘A[`clipzlib.cɕ܂B
 *	- GSM֘A[`clipgsm.cɕ܂B
 *	* Sat Oct 12 10:35:00 JST 2002 Naoyuki Sawa
 *	- 64rbgZCu֐ǉ܂BeXg͂܂s[łB
 *	* Mon Oct 14 12:31:00 JST 2002 Naoyuki Sawa
 *	- render_object()ǉ܂B
 *	* Thu Oct 17 18:00:00 JST 2002 Naoyuki Sawa
 *	- pceAppInit()/pceAppExit()ɁATEh̏E~ǉ܂B
 *	  yCȕE~͍sĂ܂̂ŁA
 *	  KvɉăAvP[VŏE~sĂB
 *	  iŉyCȕE~sƁAyCuKvȂ
 *	    AvP[V܂ŁAꗥ50KBxsrft@CTCYĂ܂܂j
 *	- sound_play()/sound_stop()ǉ܂B
 *	* Sun Nov 3 00:12:00 JST 2002 Naoyuki Sawa
 *	- pceAppExit()ɁAԊOʐM̒~ǉ܂B
 *	* Tue Nov 5 19:00:00 JST 2002 Naoyuki Sawa
 *	- render_font()/render_string()/render_printf()ǉ܂B
 *	* Wed Nov 6 06:15:00 JST 2002 Naoyuki Sawa
 *	- render_font_framed()/render_string_framed()/render_printf_framed()ǉ܂B
 *	  9dˏĂ̂ŁAƂĂxłB
 *	  rbgp^[dˍ킹悤ɂ΍ł܂A܂Ă܂B
 */
#include "clip.h"
#include "clipdobj.c" /* pceLCDDrawObject */

/*****************************************************************************
 *	O[oϐ
 *****************************************************************************/

/* S1C33 Family CRpCpbP[Wł́Aerrno̓AvP[VŒ`Kv܂B
 * [S5U1C33000C_J.pdf p.140]
 */
int errno;

/*****************************************************************************
 *	[Jϐ
 *****************************************************************************/

/* vOIɎs֐ւ̃|C^B
 * atexit()œo^܂B(݂̎ł͈x݂̂łB)
 * NULLȂA܂o^Ă܂B
 */
static void (*exit_func)();

/* * 󂫃̑啔malloc()pq[vƂĊmۂ܂B
 *   AvP[Ṽmۂ́ApceHeapAlloc()ł͂Ȃmalloc()gĂB
 * * pceFilenAPIpceHeapAlloc()gA4`8KBx̃mۂŝŁA
 *   VXepq[v̈ƂāA󂫃cĂKv܂B
 * * BIOS1.18݁ApceFileLoad()(0x2000-32)oCg̃mۂŝő̂悤łA
 *   ۂɂ́AAvP[VReLXgpceFileLoad()ڌĂ΂邱Ƃ͂܂B
 *   pceFileLoad()Ă΂菇͎̂ƂłF(runapp.cAppStart()֐Q)
 *	1. pceAppExecFile() c st@Ci[AAvP[VIv
 *	2. AppLoop()甲 c AvP[VI
 *	3. ResetHeap(INITAPPEXTBUFF) c q[v̈0x13e000`0x13ffffɐݒ
 *	4. search_app() -> pceFileLoad() c q[v̈悩(0x2000-32)oCg̃mہA
 *	                                    ̃gĎst@CWJB
 *	5. InitHeapAndSP() c q[v̈AvP[V`0x13ffffɐݒ
 *	6. AppInit(),AppLoop() c AvP[VsJn
 *   ̂悤ɁApceFileLoad()Ă΂ƂAAvP[V͊ɏIĂ܂B
 *   AvP[VIAq[v̈͋I0x13e000`0x13ffffɍĐݒ肳܂B
 *   ]āApceFileLoad()mۂ镪̃cĂKv͂܂B
 * * pceFileCreate/Rename/Delete()A4096oCg(=BLOCKSIZE)̃mۂs܂B
 *   BIOS1.18݁AAvP[VReLXgŃmۂsAPÍA3łB
 *   ƂA(mۂ郁{Ǘ̈)̋󂫃΁A蓖Đ܂B
 *   ȏAcĂȂ΂Ȃ󂫃̍ŏTCÝF
 *	BLOCKSIZE + sizeof(HEAPMEM)
 *   ƂȂ܂B
 * * BIOSXVɂāAƑ傫ȃmۂsAPIǉꂽꍇ́A
 *   HEAPMARGIN𒲐Kv܂B
 */
#define HEAPMARGIN	(BLOCKSIZE + sizeof(HEAPMEM))	/* VXepq[v̈TCY */
static void* heap;					/* malloc()pq[v̈       */

/*****************************************************************************
 *	P/ECEpE[maint[[N
 *****************************************************************************/

static int  app_init();
static void app_proc();
static void app_exit();

/* * ėpWX^̂AۑKv̂́Ar0`r3݂̂łB
 *   [S5U1C33000C_J.pdf p.84]
 */
typedef struct _CONTEXT {
	int r0, r1, r2, r3;
	int* sp;
} CONTEXT;
/* * system_contextuser_context́AstaticϐƂĂ̂łA
 *   CRpĆAasmubNŕϐ삵Ă邱Ƃ𔻒fłA
 *   "system_context`Ă邪AgĂȂ"ƌx܂B
 *   ́Ax}̂߂ɁAO[oϐƂ邱Ƃɂ܂B
 */
CONTEXT system_context;	/* VXeReLXgۑp */
CONTEXT user_context;	/* [U[ReLXgۑp */

void
pceAppInit()
{
	int i;

	/* [U[ReLXg܂B */
	/* Fri Jun 21 19:22:00 JST 2002 Naoyuki Sawa
	 * - ܂ŁAVXeX^bNƃ[U[X^bÑTCY̕źA
	 *       1000`1C00:[U[X^bN(3KB)
	 *       1C00`2000:VXeX^bN(1KB)
	 *   ƂĂ܂AGSMĐ@\̒ǉɔAVXeX^bN𑝗ʂ܂B
	 * - GSMĐ[`́A[U[^VXeǂ̃X^bNg\܂B
	 *   TEh荞݂[U[ReLXgŔꍇ̓[U[X^bNB
	 *   TEh荞݂VXeReLXgŔꍇ̓VXeX^bNg܂B
	 * - GSMĐ@\gꍇAVXeX^bN1C00`2000ł͑܂łB
	 *   ƂAKv肬̃VXeX^bNTCY1B00`2000̂悤łB
	 * - 炵1B80`ɂĂ݂ƁASTART̃j[߂Ƃɗ܂B
	 *   P/ECE WatcherŊώ@ƁA1B10܂ŎgĂ܂BȂ댯łB
	 * - ŁA]T1A00`2000܂ŃVXeX^bNƂ邱Ƃɂ܂B
	 *   ŁAVXeX^bNɂ͈ꉞA256oCgx̗]T邱ƂɂȂ܂B
	 * - [U[X^bNɂ͂܂]T悤łB
	 *   AvP[Vɂ܂Aʂ񂬂̃~jQ[ŎĂ݂ƂA
	 *   1800`1A00xgĂ炸A܂2KBx̗]T悤łB
	 */
	user_context.sp = (int*)0x1A00;		/* 1000`1A00:[U[X^bN(2.5KB) */
						/* 1A00`2000:VXeX^bN(1.5KB) */
	*--user_context.sp = (int)app_exit;	/* app_init()ԂɌĂ΂֐ */
	*--user_context.sp = (int)app_init;	/* Gg[|Cg(̒mainĂ) */

	/* STEh`l̃{[őɂ܂B
	 * J[l̓AvP[VNɃ{[ĂȂ̂ŁA
	 *   AvP[V̒ŏȂƑO̐ݒpł܂܂I
	 */
	for(i = 0; i < 4; i++) pceWaveSetChAtt(i, 0/*0Ń{[ő*/);

	/* pceLCDDrawObjectCXg[܂B */
	hook_LCDDrawObject();

	/* Zx̃oh߁ALCDCď܂B */
	lcd_init();
}

void
pceAppProc(int count)
{
	/* yield()ƃX^bNt[̍\킹Kv̂ŁA
	 * Ȃ̊֐oR܂B
	 */
	app_proc();
}

void
pceAppExit()
{
	/* atexit()œo^ꂽIԐ΁AĂяo܂B */
	if(exit_func != NULL) exit_func();

	/* pceLCDDrawObjectACXg[܂B */
	unhook_LCDDrawObject();

	/* mɃTEh~܂B */
	pceWaveStop(0);

	/* mɐԊOʐM~܂B */
	pceIRStop();
}

static int
app_init()
{
	int size;

	/* * s\̂鏉́ApceAppInit()ł͂ȂAōsĂB
	 *   pceAppInit()̒ŎsoĂAAvP[VI̎iȂłB
	 *   pceAppInit()̒pceAppReqExit()gĂʂ܂!! (BIOS1.18)
	 * * app_init()pceAppProc()̒Ȃ̂ŁApceAppReqExit()LłB
	 */

	/* malloc()pq[v̈܂B
	 * * J͍sĂ܂B
	 *   AvP[VÍAVXeɂq[vZbgɔCĂ܂B
	 */
	size = pceHeapGetMaxFreeSize();
	size -= HEAPMARGIN;
	if(size <= 0) DIE();    /* VXeq[vȂقǁA󂫃ɒ[ɏȂ */
	heap = pceHeapAlloc(size);
	if(heap == NULL) DIE(); /* HEAPMARGIN{oCg̋󂫂ȂAǗ̈悪Ȃ */
	memset(heap, 0x77, size); /* fobOՂ悤ɁAKȒlłŖ߂Ă܂ */
	ansi_InitMalloc((int)heap, (int)heap + size);

	/* AvP[V`̃Gg|CgցB */
	return main();
}

static void
app_proc()
{
	asm("
	; VXeReLXgޔ܂B
	xld.w %r7, system_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; [U[ReLXg𕜌܂B
	xld.w %r7, user_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

static void
app_exit()
{
	asm("
	; VXeReLXg𕜌܂B
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4

	; Iv𔭍s܂B
	ld.w %r12, %r10
	xcall pceAppReqExit
	");
}

void
yield()
{
	asm("
	; [U[ReLXgޔ܂B
	xld.w %r7, user_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; VXeReLXg𕜌܂B
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

int
atexit(void (*func )())
{
	/* ݂̎ł́Axڂ͎s܂B */
	if(exit_func != NULL) return -1;

	/* ֐|C^i[܂B */
	exit_func = func;

	return 0;
}

/*****************************************************************************
 *	ʃx֐/_~[֐ : WbCu
 *****************************************************************************/

/* ʃx֐F	WCuĂ΂́B
 *			AvP[V璼ڎgƂ͂܂B
 * _~[֐F		WCũwb_Ő錾Ă邪A
 *			ĂȂiCuɑ݂ȂjB
 * ]āÅ֐ clippce.h Ő錾Kv͂܂B
 */

/* exit(),abort()Ă΂܂B */
void
_exit()
{
	pceAppReqExit(0); /* Iv𔭍sāA */
	yield();          /* VXeɐԂ */
	/* Ayield()͐Ԃ܂B      */
}

/* S1C33 Family CRpCpbP[Wcalloc()ɂ͖肪܂B
 * calloc(`, 1)̌`ŎgƂɁAKvʂ4{̃mۂ悤Ƃ܂B
 * 炭Â悤ȎɂȂĂ̂Ǝv܂B
 * 	void* calloc(size_t num, size_t size) {
 * 		int n;
 * 		void* p;
 * 		size = size + 3 & ~3;		// vfTCY4oCgPʂɐ؂グ
 * 		n = num * size;			// 蓖ăoCgvZ
 * 		p = malloc(n);			// 蓖ĂsĂ݂
 * 		if(p != NULL) memset(p, 0, n);	// Ȃ[NA
 * 		return p;
 * 	}
 * ł͖ʂ܂B
 * Ocalloc()pӂACucalloc()u邱Ƃɂ܂B
 * QlFP.J.vEK[uWbCu ANSI/ISO/JIS CKivigbpj
 * @@@@@ 432y[W }13.30 calloc.c
 */
void*
calloc(size_t num, size_t size)
{
	size_t n = num * size;
	void* p = malloc(n);
	if(p) memset(p, 0, n);
	return p;
}

/****************************************************************************
 *	ʃx֐ : 64rbgZCu
 ****************************************************************************/

/* * CRpC(gcc33)̂long longFAƃR[ĥłA
 *   64rbgZCu܂܂ĂȂ̂ŁAg܂łB
 *   ŁA64rbgZCuOŎĂ݂܂B
 *
 * * {́Aidiv.lib(]ZCu)fp.lib(_ZCu)A
 *   fpp.lib(_Cu)ƓlɁARpCɕtėׂ̂Ǝv̂łA
 *   Ȃ܂܂Ă܂B
 *   P/ECE̔zzZbgɓYꂽƂ̂ł͂ȂAEPSON̔zzZbgɓĂȂ悤łB
 *   iCRpC}jÃCuꗗɂڂĂȂƂ琄j
 *   Agcc33 long long Z̏o̓R[hɖ肪肵āA
 *   ΉOĂ܂̂m܂B
 *   Ał͐R[hĂ悤Ɍ܂̂ŁA
 *   64rbgZCupӂ long long ʂɎgƔf܂B
 *   ̂ƂAƓĂ悤Ɏv܂B
 *
 * * ߂lE錾Ă͂܂I
 *   錾ƁA]vȃv[OEGs[OR[hĂ܂܂B
 *
 * * _llong long̕ϊT|[g֐͖łB
 *   __fixsfdi,__fixunssfdi,__floatdisfȂǂĂ΂悤łB
 *   ܂Afloatlong long֕ϊƂɁA__cmpdi2Ƃ֐Ă΂܂B
 *   O琄long long̔r֐̂悤łAł͎glq܂B
 *   ʏlong long̔rł́ACRpCCCR[h𐶐Ă̂łB
 *   Ȃfloatlong longւ̕ϊA__cmpdi2Ă΂̂słB
 *
 * * 64rbg萔̃TtBbNX́ullv(t)uullvijłB
 *   ̃TtBbNXtȂĂA傫Ȓ萔͂64rbgƂĔF܂A
 *   RpCɌx\܂B
 *   <>
 *	long long a = 1000000000000000000;   // xi͂njj
 *	long long b = 1000000000000000000ll; // nj
 */

void/*long long*/
__negdi2(/*long long a*/) /* ] */
{
	asm("
	ld.w %r10, 0		; %r11:%r10 = 0:0 - %r13:%r12
	ld.w %r11, 0
	sub %r10, %r12
	sbc %r11, %r13
	");
}

void/*long long*/
__adddi3(/*long long a, long long b*/) /* Z */
{
	asm("
	ld.w %r10, %r12		; %r11:%r10 = %r13:%r12 + %r15:%r14
	ld.w %r11, %r13
	add %r10, %r14
	adc %r11, %r15
	");
}

void/*long long*/
__subdi3(/*long long a, long long b*/) /* Z */
{
	asm("
	ld.w %r10, %r12		; %r11:%r10 = %r13:%r12 - %r15:%r14
	ld.w %r11, %r13
	sub %r10, %r14
	sbc %r11, %r15
	");
}

/* * ÓTIȕMZ^̏Z[`łB
 *   u64rbg~64rbg64rbgvȂ̂ŁAlKv͂܂B
 *   ۂgcc33́A64rbgZ̏ꍇ͕tEɊւ炸A
 *   __muldi3ĂяoR[h𐶐悤łBi__umuldi3͂܂j
 * * ƂeNjbÑF
 *   S1C33ɂ̓L[tÕ݂VtgE[e[g܂B
 *   搔1rbgÂEVtgčŉʃrbg𒲂ׂKv܂A
 *   WX^AĉEVtg鏈́A܂ƂɏƔɒȂ܂B
 *   Ⴆ΁A%r15%r14AĉE1rbgVtg鏈́AȊɂȂ܂B
 *	ld.w %r4, %r15	; %r4'31 = %r15'0
 *	xsll %r4, 31	; 3ߕKvł
 *	srl %r15, 1
 *	srl %r14, 1
 *	or %r14, %r4
 *   CRpĆA1rbgVtgɂĂl̃R[h𐶐܂A
 *   ƊȒPȕ@܂B
 *	add %r14, %r14
 *	adc %r15, %r15	; C <- %r15'31
 *   āAMZ^Z[`ł́A搔ŉʃrbg璲ׂčŝŁAEVtgKvłB
 *   ȂOq̒ʂAS1C33 CPUł́AVtgɊrׂĉEVtg͓̂łB
 *   ŁA搔̑SrbgE]Ă܂܂傤B
 *   Ă΁AȒPȍVtggȂAŏʃrbg𒲂ׂ΂ƂɂȂ܂B
 *	swap %r14, %r14		; %r14:%r15 = E](%r15:%r14)
 *	mirror %r14, %r14	; WX^͓ւȂ̂ŁA]%r14ʂɂȂ邱Ƃɒ
 *	swap %r15, %r15
 *	mirror %r15, %r15
 *  S1C33̃VtgE[e[g߂ł́Aŏʃrbg͒PɎ̂ĂĂ܂܂A
 *  add/adcɂ鍶VtgȂAŏʃrbgL[tOɓ̂ŁA
 *  VtgɃL[tO𒲂ׂ邾ōς݂܂B
 */
void/*long long*/
__muldi3(/*long long a, long long b*/) /* Z */
{
	asm("
	ld.w %r10, 0		; %r11:%r10 = 0:0
	ld.w %r11, 0
	swap %r14, %r14		; %r14:%r15 = E](%r15:%r14)
	mirror %r14, %r14
	swap %r15, %r15
	mirror %r15, %r15
__muldi3_L10:
	add %r15, %r15		; C:%r14:%r15 <<= 1
	adc %r14, %r14
	jruge __muldi3_L30	; if(C) {
	add %r10, %r12		;   %r11:%r10 += %r13:%r12
	adc %r11, %r13
__muldi3_L20:
	add %r12, %r12		;   %r13:%r12 <<= 1
	jp.d __muldi3_L10	;   goto L10
	adc %r13, %r13
__muldi3_L30:			; } else {
	jrne __muldi3_L20	;   if(%r14 != 0) goto L20
	or %r15, %r15		;   if(%r15 != 0) goto L20
	jrne __muldi3_L20
				; }
	");
}

/* __divdi3/__udivdi3̃T|[g֐B
 * S1C33000RACPU}jAdiv0s/12s/3s̏ڍאǂɎ܂B
 * * [ZO͐܂B
 * * S1C33̊֐ĂяoKǂA%r11:%r10ɏԂ܂B
 *   ɉāA%r13:%r12ɗ]Ԃ܂Bi__moddi3/__umoddi3ŎgĂ܂j
 *   {́A%r13:%r12ɖ߂lZbgĂAƕԂ邩ǂۏ؂Ȃ̂łA
 *   Ƃ肠̊֐̓v[OEGs[OR[h܂܂Ȃ̂ŁAv݂łB
 * * __divdi3/__udivdi3炵gȂ̂ŁAstatic֐ɂ̂łAƁA
 *   CRpCugĂȂstaic֐܂vƂӖ̌xoĂ܂܂B
 *   CRpĆA__divdi3/__udivdi3̒asm()ubŇĂяoFȂłB
 *   dȂ̂ŁAO[o֐ɂĂ܂B
 * * div3s̕]ƋꂵłAuadc %rd, imm6vȂ̂Ŏ~ނ𓾂܂...
 *   uadc %rd, imm6v΁unot %r10,%r10; not %r11,%r11; add %r10,1; adc %r11,0vƂł̂ɁB
 *   ł܂ߐ1ȂATCNő2Ȃ̂ŁAĕςȂȁH
 * * ܂eXgs\Ȃ̂ŁAoOcĂ邩m܂B
 */
void/*long long*/
__div00(/*long long a, long long b*/) /*  */
{
	asm("
	;***** div0s *****
	ld.w %r10, %r12		; %r13:%r12:%r11:%r10 = 0:0:%r13:%r12
	ld.w %r11, %r13
	ld.w %r12, 0
	ld.w %r13, 0
	;***** div1 *****
	xld.w %r4, 64		; %r4 = 64
__div00_L10:
	add %r10, %r10		; %r13:%r12:%r11:%r10 <<= 1
	adc %r11, %r11
	adc %r12, %r12
	adc %r13, %r13
	sub %r12, %r14		; %r13:%r12 -= %r15:%r14
	sbc %r13, %r15
	jrult __div00_L20	; if(!C) {
	jp.d __div00_L30	;   %r10'0 = 1
	or %r10, 1
__div00_L20:			; } else {
	add %r12, %r14		;   %r13:%r12 += %r15:%r14
	adc %r13, %r15
__div00_L30:			; }
	sub %r4, 1		; if(--%r4) goto L10
	jrne __div00_L10
	;***** div2s *****
	;***** div3s *****
	");
}
void/*long long*/
__div01(/*long long a, long long b*/) /*  */
{
	asm("
	;***** div0s *****
	ld.w %r10, %r12		; %r13:%r12:%r11:%r10 = 0:0:%r13:%r12
	ld.w %r11, %r13
	ld.w %r12, 0
	ld.w %r13, 0
	;***** div1 *****
	xld.w %r4, 64		; %r4 = 64
__div01_L10:
	add %r10, %r10		; %r13:%r12:%r11:%r10 <<= 1
	adc %r11, %r11
	adc %r12, %r12
	adc %r13, %r13
	add %r12, %r14		; %r13:%r12 += %r15:%r14
	adc %r13, %r15
	jruge __div01_L20	; if(C) {
	jp.d __div01_L30	;   %r10'0 = 1
	or %r10, 1
__div01_L20:			; } else {
	sub %r12, %r14		;   %r13:%r12 -= %r15:%r14
	sbc %r13, %r15
__div01_L30:			; }
	sub %r4, 1		; if(--%r4) goto L10
	jrne __div01_L10
	;***** div2s *****
	;***** div3s *****
	not %r10, %r10		; %r11:%r10 = -%r11:%r10
	add %r10, 1
	jruge.d __div01_L60
	not %r11, %r11
	add %r11, 1
__div01_L60:
	");
}
void/*long long*/
__div10(/*long long a, long long b*/) /*  */
{
	asm("
	;***** div0s *****
	ld.w %r10, %r12		; %r13:%r12:%r11:%r10 = -1:-1:%r13:%r12
	ld.w %r11, %r13
	ld.w %r12, -1
	ld.w %r13, -1
	;***** div1 *****
	xld.w %r4, 64		; %r4 = 64
__div10_L10:
	add %r10, %r10		; %r13:%r12:%r11:%r10 <<= 1
	adc %r11, %r11
	adc %r12, %r12
	adc %r13, %r13
	add %r12, %r14		; %r13:%r12 += %r15:%r14
	adc %r13, %r15
	jrult __div10_L20	; if(!C) {
	jp.d __div10_L30	;   %r10'0 = 1
	or %r10, 1
__div10_L20:			; } else {
	sub %r12, %r14		;   %r13:%r12 -= %r15:%r14
	sbc %r13, %r15
__div10_L30:			; }
	sub %r4, 1		; if(--%r4) goto L10
	jrne __div10_L10
	;***** div2s *****
	add %r12, %r14		; %r13:%r12 += %r15:%r14
	adc %r13, %r15
	or %r12, %r13
	jrne __div10_L40	; if(%r13:%r12 == 0) {
	add %r10, 1		;   %r11:%r10 += 1
	jruge __div10_L50
	jp.d __div10_L50
	add %r11, 1
__div10_L40:			; } else {
	sub %r12, %r14		;   %r13:%r12 -= %r15:%r14
	sbc %r13, %r15
__div10_L50:			; }
	;***** div3s *****
	not %r10, %r10		; %r11:%r10 = -%r11:%r10
	add %r10, 1
	jruge.d __div10_L60
	not %r11, %r11
	add %r11, 1
__div10_L60:
	");
}
void/*long long*/
__div11(/*long long a, long long b*/) /*  */
{
	asm("
	;***** div0s *****
	ld.w %r10, %r12		; %r13:%r12:%r11:%r10 = -1:-1:%r13:%r12
	ld.w %r11, %r13
	ld.w %r12, -1
	ld.w %r13, -1
	;***** div1 *****
	xld.w %r4, 64		; %r4 = 64
__div11_L10:
	add %r10, %r10		; %r13:%r12:%r11:%r10 <<= 1
	adc %r11, %r11
	adc %r12, %r12
	adc %r13, %r13
	sub %r12, %r14		; %r13:%r12 -= %r15:%r14
	sbc %r13, %r15
	jruge __div11_L20	; if(C) {
	jp.d __div11_L30	;   %r10'0 = 1
	or %r10, 1
__div11_L20:			; } else {
	add %r12, %r14		;   %r13:%r12 += %r15:%r14
	adc %r13, %r15
__div11_L30:			; }
	sub %r4, 1		; if(--%r4) goto L10
	jrne __div11_L10
	;***** div2s *****
	sub %r12, %r14		; %r13:%r12 -= %r15:%r14
	sbc %r13, %r15
	or %r12, %r13
	jrne __div11_L40	; if(%r13:%r12 == 0) {
	add %r10, 1		;   %r11:%r10 += 1
	jruge __div11_L50
	jp.d __div11_L50
	add %r11, 1
__div11_L40:			; } else {
	add %r12, %r14		;   %r13:%r12 += %r15:%r14
	adc %r13, %r15
__div11_L50:			; }
	;***** div3s *****
	");
}

/* * ƂeNjbÑF
 *   S1C33ɂ́AN()tOɂ򂪂܂B
 *   AZ80x86ŎgĂ悤ȁAȊ̃R[h͎g܂B
 *	or a
 *	jp m, (l̏)
 *	(l̏)
 *   andŒׂĂłA0x80000000Ƃand͍܂B
 *	xand %r13, 0x80000000	; 3ߕKvł
 *	jrne (l̏)
 *	(l̏)
 *   ŁAscan1g܂傤B
 *   scan1́Aŏʃrbg1𔭌ꍇ̂݁AZtOZbg܂B
 *   iȂȂAfXeBl[VWX^0ɂȂ邩łBj
 *	scan1 %r4, %r13		; %r4͔j󂳂邱ƂɒӁI
 *	jreq.d (l̏)
 *	(l̏)
 *   scan0/1͈ꌩGŕTCN߂ƎvĂ܂܂A1TCN߂łB
 *   fBCh߂ɂł܂B
 */
void/*long long*/
__divdi3(/*long long a, long long b*/) /* tZ */
{
	asm("
	scan1 %r4, %r13
	jreq.d __divdi3_L10
	scan1 %r4, %r15
	xjrne __div00
	xjp   __div01
__divdi3_L10:
	xjrne __div10
	xjp   __div11
	");
}

void/*long long*/
__udivdi3(/*long long a, long long b*/) /* Z */
{
	asm("
	xjrne __div00
	");
}

void/*long long*/
__moddi3(/*long long a, long long b*/) /* t] */
{
	asm("
	xcall __divdi3
	ld.w %r10, %r12
	ld.w %r11, %r13
	");
}

void/*long long*/
__umoddi3(/*long long a, long long b*/) /* ] */
{
	asm("
	xcall __udivdi3
	ld.w %r10, %r12
	ld.w %r11, %r13
	");
}

/*****************************************************************************
 *	[eBeBF^C}
 *****************************************************************************/

void
usleep(unsigned long usec)
{
	unsigned long st, ed;

	/* !pceTimerGetPrecisionCount()̖߂l̓jAȒlł͂܂B
	 * ߂ɂpceTimerAdjustPrecisionCount()gKv܂B
	 */
	st = pceTimerGetPrecisionCount();
	do {
		ed = pceTimerGetPrecisionCount();
	} while(pceTimerAdjustPrecisionCount(st, ed) < usec);
}

/*****************************************************************************
 *	[eBeBF`
 *****************************************************************************/

void
lcd_init()
{
	unsigned char buf[100/*O{炢]TĂ܂*/], *p, cmd;
	int len, i;

	/* 炩ߏR}h쐬Ă܂B
	 * * S6B0741f[^V[g(DS_S6B0741_V21.pdf)56y[W
	 *   uReferential Instruction Set-up Flow:
	 *     Initializing with the built-in Power Supply Circuitsv
	 *   QƂĂB
	 * * eݒĺA݂P/ECEJ[l(1.18)ɍ킹Ă܂B
	 * * oi(?)LCDuOGM-128GB21T-S-KD010v̐ݒlƂ͈قȂ܂B
	 *   OGM-128GB21T-S-KD010f[^V[g(128GB21T-S-KD010.pdf)QƂĂB
	 * * 128GB21T-S-KD010.pdf4y[Wu1. FEATURESvɏĂ鐄ݒlł́F
	 *	Driving method ... 1/128 duty, 1/12 bias
	 *   ƂȂĂAP/ECEJ[lł̐ݒlF
	 *	Driving method ... 1/128 duty, 1/11 bias
	 *    Ƃ͏قȂ܂B
	 *   iP/ECEJ[l̂1/12`ՂARg1/12̂܂܂łj
	 * * A10y[Wu9. PROGRAM SETTING VALUEvɏĂ鐄ݒlł́F
	 *	BLACK     : 9990
	 *	DARK GRAY : 9900
	 *	LIGHT GRAY: 9000
	 *	WHITE     : 0000
	 *   ƂȂĂAP/ECEJ[lł̐ݒlF
	 *	BLACK     : 8880
	 *	DARK GRAY : 8800
	 *	LIGHT GRAY: 8000
	 *	WHITE     : 0000
	 *   Ƃ͏قȂ܂B
	 * * biaslƃpbgOGM-128GB21T-S-KD010̐ݒlɍ킹Ă݂ƁA
	 *   OGM-128GB21T-S-KD010̐ݒlł[ꂢɌ邱Ƃ킩܂B
	 *   biaslŔ֒ApbgŔZ֒̂ŁA
	 *   łāAǁAƓ悤ȔZxɂȂ̂Ǝv܂B
	 * * P/ECEJ[lEOGM-128GB21T-S-KD010ǂɍ킹Ă(ȂƂڂ)
	 *   Ǝv̂łAŜ߂ɁAP/ECEJ[lɍ킹邱Ƃɂ܂B
	 */
	p = buf;
	/* User Application Setup by Internal Instructions */
	/* [Display Duty Select] */
	*p++ = 0x48; *p++ = 128;
	/* [ADC Select] */
	*p++ = 0xa0 + 0;
	/* [SHL Select] */
	*p++ = 0xc0 + 8;
	/* [COM0 Register Select] */
	*p++ = 0x44; *p++ = 0;
	/* User LCD Power Setup by Internal Instructions */
	/* [Oscillator ON] */
	*p++ = 0xab;
	/* [DC-DC Step-up Register Select] */
	*p++ = 0x64 + 2;
	/* [Regulator Resistor Select] */
	*p++ = 0x20 + 6;
	/* [Electronic Volume Register Select] */
	*p++ = 0x81; *p++ = pceLCDSetBright(INVALIDVAL);
	/* [LCD Bias Register Select] */
	*p++ = 0x50 + 6;
	/* [Gray-scale Select] */
	*p++ = 0x94;			/* Set FRC and PWM mode */
	*p++ = 0x88 + 0; *p++ = 0x00;	/* Set white mode and 1/2 frame */
	*p++ = 0x88 + 1; *p++ = 0x00;	/* Set white mode and 3/4 frame */
	*p++ = 0x88 + 2; *p++ = 0x08;	/* Set light gray mode and 1/2 frame */
	*p++ = 0x88 + 3; *p++ = 0x00;	/* Set light gray mode and 3/4 frame */
	*p++ = 0x88 + 4; *p++ = 0x88;	/* Set dark gray mode and 1/2 frame */
	*p++ = 0x88 + 5; *p++ = 0x00;	/* Set dark gray mode and 3/4 frame */
	*p++ = 0x88 + 6; *p++ = 0x88;	/* Set black mode and 1/2 frame */
	*p++ = 0x88 + 7; *p++ = 0x08;	/* Set black mode and 3/4 frame */
	/* (Zbgt[ɍڂĂȂ) */
	*p++ = 0x4c; *p++ = 0x1f;	/* Set N-line inversion */
	*p++ = 0x40; *p++ = 80;		/* Set initial display line register */
	/* [Power Control] */
	*p++ = 0x28 + 7;
	len = p - buf; /* R}hoCg */

	/* LCDCo̓|[goRɐ؂ւ܂B
	 * * ݂P/ECEJ[l(1.18)́AP1xn̓o͕ݒ肵Ă܂B
	 *   Zbg̏ԂłuINv̂܂܂ɂȂĂ܂B
	 * * P32,15,16o̓|[gɐ؂ւOɓo͕ݒ肵ĂȂƁA
	 *   ͓młԂăS~MĂ܂Ƃ܂B
	 * * ܂AP32,15,16o̓|[gɐ؂ւOSCLK0ɂĂȂƁA
	 *   ȂSCLK1ɂȂăS~MĂ܂Ƃ܂B
	 *   Ô߁ASID0ɂĂƂɂ܂B
	 * * Sun Oct 20 21:37:00 JST 2002 Naoyuki Sawa
	 *   c33209.hɃ|[gSIO@\gWX^(0x402d7)̒`ǉ܂B
	 *   ̃|[g͂ԂS1C33208S1C33209̎Ɋgꂽ̂Ǝv̂ŁA
	 *   IWic33208.hɂ͍ڂĂ܂łB
	 *   |[gSIO@\gWX^̒`ǉ̂ŁA
	 *   ܂Ń|[gAhX𒼐ڎw肵P16/P15/P32̐ݒsĂA
	 *   bPSIO3_CFEX_*g悤ɕύX܂B
	 */
	bP3_IOC3_IOC32 = 0;	/* CSB̖߂  -> IN  (̂܂) */
	bP1_IOC1_IOC15 = 1;	/* SCLK       -> OUT (K{I) */
	bP1_IOC1_IOC16 = 1;	/* SID        -> OUT (K{I) */
	bP3_IOC3_IOC33 = 1;	/* RESETB     -> OUT (̂܂) */
	bP1_P1D_P15D = 0;	/* SCLKo͒l -> 0   (K{I) */
	bP1_P1D_P16D = 0;	/* SID o͒l -> 0   (Ô) */
	bPSIO3_CFEX_SSOUT3 = 0;	/* P16        -> P16            */
	bPSIO3_CFEX_SSCLK3 = 0;	/* P15        -> P15            */
	bPSIO3_CFEX_SSRDY3 = 0;	/* P32        -> P32            */

	/* LCDCZbg܂B
	 * * S6B0741f[^V[g(DS_S6B0741_V21.pdf)67y[W
	 *   uReset Input TimingvQƂĂB
	 *   iۂɂ́AP/ECECPUx(24MHz)ȂA񂺂҂ȂĂvłj
	 */
	bP3_P3D_P33D = 0;	/* RESETB -> Zbg */
	usleep(1 + 1/*덷*/);	/* ȂƂ1000[ns] */
	bP3_P3D_P33D = 1;	/* RESETB ->      */
	usleep(1 + 1/*덷*/);	/* ȂƂ1000[ns] */

	/* R}h𔭍s܂B */
	bP2_P2D_P21D = 0;	/* RS  -> R}h */
	bP2_P2D_P20D = 0;	/* CSB -> I     */
	p = buf;
	while(len-- != 0) {
		cmd = *p++;
		/* rbg7`0̏őoB
		 * * ҂ԂɂẮAS6B0741f[^V[g(DS_S6B0741_V21.pdf)66y[W
		 *   uSerial Interface CharacteristicsvQƂĂB
		 *   iۂɂ́AP/ECECPUx(24MHz)ȂA񂺂҂ȂĂvłj
		 */
		for(i = 0; i < 8; i++, cmd <<= 1) {
			bP1_P1D_P15D = 0;
			bP1_P1D_P16D = cmd & 0x80 ? 1 : 0;
			usleep(1 + 1/*덷*/);	/* ȂƂ30[ns] */
			bP1_P1D_P15D = 1;
			usleep(1 + 1/*덷*/);	/* ȂƂ30[ns] */
		}
	}
	bP2_P2D_P20D = 1;	/* CSB ->  */

	/* [Power Control] Waiting for Stabilizing the LCD Power Levels ́A
	 * f[^V[gɑ҂ԂK肳ĂȂ̂ŁAÔߒ߂ɑ҂܂B
	 * iۂɂ́AP/ECECPUx(24MHz)ȂA񂺂҂ȂĂvłj
	 */
	usleep(1000);		/* 1~b҂ĂΏ[ȁH */

	/* LCDCVAC^[tFCXoRɖ߂܂B
	 * o͕͊֌WȂ̂ŁAɖ߂Kv͂܂B
	 */
	bPSIO3_CFEX_SSOUT3 = 1;	/* P16        ->  SSOUT3 */
	bPSIO3_CFEX_SSCLK3 = 1;	/* P15        -> #SSCLK3 */
	bPSIO3_CFEX_SSRDY3 = 1;	/* P32        -> #SSRDY3 */

	/* RESETB[qɂ郊ZbǵADisplay ON/OFF:OFF ɂȂĂ܂B
	 * ̂ƕKvɉāApceLCDDispStart()ĂяoĂB
	 * iȂ݂ResetR}h̏ꍇ́ADisplay ON/OFFԂێ܂j
	 */
}

void
draw_object(PIECE_BMP* src, int dx, int dy, int sx, int sy, int w, int h, int param)
{
	DRAW_OBJECT obj;

	pceLCDSetObject(&obj, src, dx, dy, sx, sy, w, h, param);
	pceLCDDrawObject(obj);
}

void
render_object(RENDER* render, int dx, int dy, int sx, int sy, int w, int h, int param)
{
	DRAW_OBJECT obj;
	PIECE_VRAM* vram = (PIECE_VRAM*)render->surface;
	PIECE_BMP* pbmp = render->context->texture;
	if(pbmp == NULL) DIE(); /* eNX`wK{ */

	/* ]ݒB */
	obj.dest = vram;
	obj.dx = dx;
	obj.dy = dy;
	obj.dw = w;
	obj.dh = h;

	/* ]ݒB */
	obj.src = pbmp;
	obj.sx = sx;
	obj.sy = sy;
	obj.clip.left = render->left;
	obj.clip.top = render->top;
	obj.clip.right = render->right;
	obj.clip.bottom = render->bottom;

	/* ̑ݒB */
	obj.param = param;
	obj.type = TYPE_BMP;

	/* `B */
	pceLCDDrawObject(obj);
}

/****************************************************************************
 *	[eBeBFtHg
 ****************************************************************************/

/*
#############
SJISJISϊ
#############

==============
JISX0208SJIS
==============

R[h0x2121
(R[h&0x100)0łȂ΃R[h0x9E,0Ȃ΃R[h0x40𑫂
ʃoCg0x7FȏȂ΃R[h1𑫂
[ʃoCg̏]ʃoCgEɂPrbgVtgA0x81𑫂
(0xA000<=R[h)Ȃ΃R[h0x4000𑫂

==============
SJISJISX0208
==============

(0xE000<=R[h)Ȃ΃R[h0x4000
[ʃoCĝ]ʃoCg0x81PrbgɃVtg
ʃoCg0x80ȏȂR[hP
ʃoCg0x9EȏȂR[h0x100𑫂AR[h0x9EBłȂ΃R[h0x40
R[h0x2121𑫂B

uR[h0x100𑫂AR[h0x9Ev
Ƃ̂͂܂C
uʃoCgɂP𑫂CʃoCg0x9Ev
łC
uR[hŜ0x62𑫂v
Ƃł܂D

-----------------------------------------------------------------------------
wR[h܂ߒmx
(http://www.d2.dion.ne.jp/~imady/kcode/kcodemame.html)
*/

static const unsigned char font_size[3][2] = { {5,10}, {8,16}, {4,6} };

/* VvCuput_1char()֐(\usr\PIECE\lib\src\simple\symbol.c)Qlɂ܂B
 * ܂ApceFontPut()֐(\usr\PIECE\sysdev\pcekn\font.c)ɕāAr[|[g/Oɂꍇs܂B
 * tHg`̈悪SɃr[|[gȂANbsOȗA{xɕ`ł܂B
 */
unsigned short
render_font(RENDER* render, int x, int y, unsigned short code, int type, int color)
{
	SURFACE* surface;
	unsigned char* vptr;
	const unsigned char* p;
	int ofs, w, h, x_min, y_min, x_max, y_max, c;

	/* tHgTCY߂܂B */
	type &= 0x7f; /* bit7(sw)͖ */
	if(type < 0 || 2 < type) DIE(); /* ȃtHg^Cv */
	w = font_size[type][0];
	h = font_size[type][1];

	 /* p󔒂͕pɂɎw肳Ǝv̂ŁA`ȗč܂B
	  * w,h͖߂lɎĝŁAw,h擾OɃXLbvȂ悤ӁI
	  */
	if(code == ' ') goto SKIP;

	/* tHgAhX߂܂B */
	pceFontSetType(type);
	p = pceFontGetAdrs(code);

	/* ptHg`c */
	if((int)p & (1 << 31)) {
		p = (unsigned char*)((int)p & ~(1 << 31)); /* prbg낷 */
		/* `͈͂߂܂B */
		x_min = x;
		y_min = y;
		x_max = x + w;
		y_max = y + h;
		/* SɃr[|[gȂANbsOsvłB */
		if(render->left <= x_min && x_max <= render->right &&
		   render->top  <= y_min && y_max <= render->bottom) {
			surface = render->surface;
			ofs = surface->w * y + x;
			vptr = surface->vbuff + ofs;
			for(y = y_min; y < y_max; y++) {
				c = *p++;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x80) *vptr = color;
					vptr++;
					c <<= 1;
				}
				vptr += surface->w - w; /* ̍s */
			}
		/* r[|[g͂ݏoĂAvNbsOB */
		} else {
			for(y = y_min; y < y_max; y++) {
				c = *p++;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x80) render_point(render, x, y, color);
					c <<= 1;
				}
			}
		}
	/* SptHg`c */
	} else {
		w *= 2; /* SpȂ̂œ񕶎̕B߂lɎĝwύXKv */
		/* `͈͂߂܂B */
		x_min = x;
		y_min = y;
		x_max = x + w;
		y_max = y + h;
		/* SɃr[|[gȂANbsOsvłB */
		if(render->left <= x_min && x_max <= render->right &&
		   render->top  <= y_min && y_max <= render->bottom) {
			surface = render->surface;
			ofs = surface->w * y + x;
			vptr = surface->vbuff + ofs;
			for(y = y_min; y < y_max; y += 2) { /* 2CÂ` */
				c = p[0] << 16 | p[1] << 8 | p[2]; /* 3oCg2C */
				p += 3;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x800000) *(vptr + 0         ) = color;
					if(c &    0x800) *(vptr + surface->w) = color;
					vptr++;
					c <<= 1;
				}
				vptr += surface->w * 2 - w; /* s */
			}
		/* r[|[g͂ݏoĂAvNbsOB */
		} else {
			for(y = y_min; y < y_max; y += 2) { /* 2CÂ` */
				c = p[0] << 16 | p[1] << 8 | p[2]; /* 3oCg2C */
				p += 3;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x800000) render_point(render, x, y + 0, color);
					if(c &    0x800) render_point(render, x, y + 1, color);
					c <<= 1;
				}
			}
		}
	}
SKIP:
	return h << 8 | w;
}

/* VvCusymbol()֐(\usr\PIECE\lib\src\simple\symbol.c)Qlɂ܂B */
unsigned int
render_string(RENDER* render, int x, int y, const char* str, int type, int color)
{
	int ml, /*w,*/ h, xmin, ymin, xmax, ymax;
	unsigned char c1, c2;
	unsigned short code, wh;

	/* s̗LƃtHgTCY߂܂B */
	ml = !(type & 0x80);
	type &= 0x7f;
	if(type < 0 || 2 < type) DIE(); /* ȃtHg^Cv */
	/*w = font_size[type][0];*/
	h = font_size[type][1]; /* ŝݗp */

	/* `͈͂߂邽߂ɁA܂`ɐݒB */
	xmin = xmax = x;
	ymin = ymax = y;

	/* e`c */
	while((c1 = *str++) != '\0') {
		/* Sp */
		if((0x81 <= c1 && c1 <= 0x9f) || (0xe0 <= c1 && c1 <= 0xfc)) {
			if((c2 = *str++) == '\0') break; /* SprŐ؂ĂBsȕ */
			code = c1 << 8 | c2;
		/* p */
		} else {
			if(ml && c1 == '\n') { /* sȂAsR[h */
				x = xmin;
				y += h;
				continue;
			}
			code = c1;
		}

		/* `܂B */
		wh = render_font(render, x, y, code, type, color);
		x += wh & 0xff; /* ̕`ʒuE֐i߂ */

		/* `͈͂XV܂B
		 * ۂɕ`ĂXV܂I]āA񖖔̉s͕`͈͂ɉe܂B
		 */
		if(x             > xmax) xmax = x            ;
		if(y + (wh >> 8) > ymax) ymax = y + (wh >> 8);
	}

	return (ymax - ymin) << 16 | (xmax - xmin);
}

/* WJobt@Ƃ_def_vbuff[]𗘗pĂ܂B */
unsigned int
render_printf(RENDER* render, int x, int y, int type, int color, const char* fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	vsprintf(_def_vbuff, fmt, ap);
	va_end(ap);

	return render_string(render, x, y, _def_vbuff, type, color);
}

unsigned short
render_font_framed(RENDER* render, int x, int y, unsigned short code, int type, int color)
{
	int c;
	unsigned short wh;

	/* (p̕) */
	c = color >> 8 & 0xf;
	if((wh = render_font(render, x + 0, y + 0, code, type, c)) == 0) return 0;
	         render_font(render, x + 2, y + 0, code, type, c);
	         render_font(render, x + 0, y + 2, code, type, c);
	         render_font(render, x + 2, y + 2, code, type, c);

	/* () */
	c = color >> 4 & 0xf;
	render_font(render, x + 1, y + 0, code, type, c);
	render_font(render, x + 0, y + 1, code, type, c);
	render_font(render, x + 2, y + 1, code, type, c);
	render_font(render, x + 1, y + 2, code, type, c);

	/*  */
	c = color >> 0 & 0xf;
	render_font(render, x + 1, y + 1, code, type, c);

	return wh + 0x0202; /* c2sNZÂ܂ */
}

unsigned int
render_string_framed(RENDER* render, int x, int y, const char* str, int type, int color)
{
	int c;
	unsigned int wh;

	/* (p̕) */
	c = color >> 8 & 0xf;
	if((wh = render_string(render, x + 0, y + 0, str, type, c)) == 0) return 0;
	         render_string(render, x + 2, y + 0, str, type, c);
	         render_string(render, x + 0, y + 2, str, type, c);
	         render_string(render, x + 2, y + 2, str, type, c);

	/* () */
	c = color >> 4 & 0xf;
	render_string(render, x + 1, y + 0, str, type, c);
	render_string(render, x + 0, y + 1, str, type, c);
	render_string(render, x + 2, y + 1, str, type, c);
	render_string(render, x + 1, y + 2, str, type, c);

	/*  */
	c = color >> 0 & 0xf;
	render_string(render, x + 1, y + 1, str, type, c);

	return wh + 0x00020002; /* c2sNZÂ܂ */
}

/* WJobt@Ƃ_def_vbuff[]𗘗pĂ܂B */
unsigned int
render_printf_framed(RENDER* render, int x, int y, int type, int color, const char* fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	vsprintf(_def_vbuff, fmt, ap);
	va_end(ap);

	return render_string_framed(render, x, y, _def_vbuff, type, color);
}

/*****************************************************************************
 *	[eBeBFTEh
 *****************************************************************************/

static PCEWAVEINFO wave_info[4]; /* e`lWAVEBLsI */

void
sound_play(int ch, const unsigned char* data)
{
	PCEWAVEINFO* wi;

	if(ch < 0 || 3 < ch) DIE(); /* `l͈̓`FbN */
	if(memcmp(data, "MCPP", 4) != 0) DIE(); /* VOl``FbN */

	/* ̃`lpPCEWAVEINFO\̂OɁA
	 * ܂̃`lmɒ~ĂȂ΂܂B
	 */
	pceWaveAbort(ch);

	/* TEhf[^ĐJn܂B */
	wi = &wave_info[ch];
	memcpy(wi, data + 8/*VOl`ƃTCY̕*/, sizeof(PCEWAVEINFO));
	wi->pData = data + 8/*VOl`ƃTCY̕*/ + sizeof(PCEWAVEINFO);
	pceWaveDataOut(ch, wi);
}

void
sound_stop(int ch)
{
	if(ch < 0 || 3 < ch) DIE(); /* `l͈̓`FbN */

	/* ̃`l̃TEh~܂B */
	pceWaveAbort(ch);
}

/****************************************************************************
 *	[eBeBFt@C
 ****************************************************************************/

int
file_read(FILEACC* fa, void* ptr, int ofs, int len)
{
	int i, sct, sof, sln;
	char* p = (char*)ptr;

	i = 0;
	while(i < len) {
		/* ZN^̃tbVAhX擾܂B */
		sct = (ofs + i) / BLOCKSIZE;			/* sct = ݂̓ǂݍ݃ItZbg܂ރZN^ԍ                         */
		sln = pceFileReadSct(fa, NULL, sct, BLOCKSIZE);	/* sln = ̃ZN^̃f[^TCY(ŏIZN^̂sln<=BLOCKSIZEɂȂ܂) */
		if(sln == 0) break;				/* ԂItZbg                                                   */

		/* ̃ZN^ǂݍރTCY肵܂B */
		sof = (ofs + i) % BLOCKSIZE;			/* ZN^ItZbg                                                       */
		sln -= sof;					/* ZN^ItZbgȍ~ǂݍ݉\ȍőf[^TCY                 */
		if(sln > len - i) sln = len - i;		/* ǂݍ݉\ȍőf[^TCYcǂݍ݃TCYȏȂA؂l߂܂ */
		if(sln <= 0) break;				/* ԂItZbg߁A܂͓ǂݍ݃TCY0ȉw肳ꂽ(len<=0)    */

		/* ZN^obt@֓ǂݍ݂܂B */
		memcpy(p + i, fa->aptr + sof, sln);
		i += sln;
	}

	return i;
}

int
file_write(FILEACC* fa, const void* ptr, int ofs, int len)
{
	int i, sct, sof, sln;
	char* buf;
	const char* p = (const char*)ptr;

	/* v1.18݂P/ECEJ[ĺApceFileOpen()Ɏw肳ꂽmode𖳎܂B
	 *   FOMD_RDŊJt@Cɑ΂ĂpceFileWriteSct()ł܂A
	 *   FOMD_WRŊJt@Cɑ΂ĂpceFileReadSct()ł܂B
	 *   file_write()֐ɓnt@ĆAFOMD_WRŊJĂ͂łA
	 *   L̓𗘗pāApceFileReadSct()gĂ܂Ă܂B
	 */

	/* ZN^̈ꕔ邽߂ɁAZN^ŜRAMɓǂݍރobt@mۂ܂B */
	buf = (char*)malloc(BLOCKSIZE);
	if(buf == NULL) return 0;

	i = 0;
	while(i < len) {
		/* ZN^̃tbVAhX擾܂B */
		sct = (ofs + i) / BLOCKSIZE;			/* sct = ݂̏݃ItZbg܂ރZN^ԍ                             */
		sln = pceFileReadSct(fa, buf, sct, BLOCKSIZE);	/* ̃ZN^̑Sf[^擾܂B(ŏIZN^̂sln<=BLOCKSIZEɂȂ܂) */
		if(sln == 0) break;				/* ԂItZbg                                                       */

		/* ̃ZN^ɏރTCY肵܂B */
		sof = (ofs + i) % BLOCKSIZE;			/* ZN^ItZbg                                                       */
		sln -= sof;					/* ZN^ItZbgȍ~ɏ݉\ȍőf[^TCY                   */
		if(sln > len - i) sln = len - i;		/* ݉\ȍőf[^TCYc菑݃TCYȏȂA؂l߂܂ */
		if(sln <= 0) break;				/* ԂItZbg߁A܂͏݃TCY0ȉw肳ꂽ(len<=0)    */

		/* ZN^̑Sf[^̈ꕔ܂B */
		memcpy(buf + sof, p + i, sln);
		i += sln;

		/* ZN^̑Sf[^tbVɏ߂܂B */
		pceFileWriteSct(fa, buf, sct, BLOCKSIZE);	/* ŏIZN^̖ߕ́ApceFileWriteSct()ɂĐ؂l߂܂  */
								/* Ŏs邱Ƃ͂肦Ȃ͂Ȃ̂ŁAG[`FbN͍s܂ */
	}

	/* obt@J܂B */
	free(buf);

	return i;
}

FILE_INFO*
fpak_find(FILEACC* fa, const char* fname)
{
	int retval, i, ofs;
	FILE_PAC_INFO fpi;
	static FILE_INFO fi; /* ߂l͂wĂ܂ */

	/* t@CpbNǂ݂܂B */
	retval = file_read(fa, &fpi, 0, sizeof fpi);
	if(retval != sizeof fpi) return NULL; /* Ă */
	if(fpi.head != FILE_PAC_INFO_HEAD)return NULL; /* VOl`s */
	if(fpi.famount < 0) return NULL; /* t@Cs */

	/* t@Cǂ݂܂B */
	ofs = sizeof fpi;
	for(i = 0; i < fpi.famount; i++) {
		retval = file_read(fa, &fi, ofs, sizeof fi);
		if(retval != sizeof fi) return NULL; /* Ă */
		if(strncmp(fi.fname, fname, sizeof fi.fname) == 0) return &fi; /*  */
		ofs += sizeof fi; /* ̃t@Cʒu */
	}

	return NULL; /* Ȃ */
}

